
-- Cratefun 

function Initialise()

    SendMessage("Commentary.NoDefault")

    SendMessage("EFMV.Start")
    SetData("Camera.StartOfTurnCamera","Default")
    SendMessage("GameLogic.PlaceObjects")
    SendStringMessage("Camera.Disable", "Track")
    SetData("Land.Indestructable", 1)
    
    SetData("PostActivityTime", 0) -- cut back to worm as soon as sheep is dead
    SetData("TurnTime", 0)
    SetData("DefaultRetreatTime", 0) -- dont cut back to worm after firing sheep
    SetData("HotSeatTime", 0) 
    SetData("RoundTime", 60000) -- We will increase this as crates are collect and end the game when it runs out
    SetData("GameLogic.ArtilleryMode", 1)
   
    SetData("Particle.DetailObject", "Spark1")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
 
    SetData("Particle.DetailObject", "emitter_ParticleFireFlash")
    SetData("Particle.Name", "Part_Singleflame")
    SendMessage("Particle.NewEmitter")
   
    SendMessage("GameLogic.PlaceObjects")


    
    NewCrate = 1
    TextControl = 0
    Time = 6000
    Switch = 0
    EndGame = 0
    AddTime = 0
    
    MakeNewCrate()
   
    SetupWormsAndTeams()
    SetupInventories()
   
    -- Start the intro camera
    camera()
end


function RoundOver()

    SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
    SendMessage("CommentaryPanel.ScriptText")

    Result()
end



function Timer_GameTimedOut()
    EndGame = 1

    if Switch == 0 then
        RoundOver()
    end
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()

    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Prod = 0    
    CloseContainer(lock) -- must close the container ASAP
        

    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("MCa.LastGameTime", GetData("ElapsedRoundTime"))
    timetook = GetData("ElapsedRoundTime")
    goldtime = GetData("MCa.BestGold")
    silvertime = GetData("MCa.BestSilver")
    bronzetime = GetData("MCa.BestBronze")
     
    if timetook > bronzetime then
        Movie = 1
        if timetook > silvertime then
            Movie = 2
            if timetook > goldtime then
                Movie = 3
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Challenge.Result")

end

-- This will be called when a sheep snuffs it
function TurnEnded()
   SendMessage("WormManager.GetActiveTeamCount")
   TeamCount = GetData("TeamCount")
   if TeamCount == 0 then
      -- the worm just died
      RoundOver()
   else
      -- give him another go 
      StartTurn()
   end
end


function camera()
   
    SendMessage("EFMV.Start")
   
    SetData("CommentaryPanel.Comment", "Chall.Sheep1.Intro1")
    SendMessage("CommentaryPanel.ScriptText") 
    SetData("CommentaryPanel.Comment", "Chall.Sheep1.Intro2")
    SendMessage("CommentaryPanel.ScriptText") 
    SetData("CommentaryPanel.Comment", "Chall.Sheep1.Intro3")
    SendMessage("CommentaryPanel.ScriptText") 
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2,Pos3,OrbitStart")
    SetData("Camera.Path.Knots.LookAt", "Look1,OrbitCentre")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",150)
    SendMessage("Camera.Path.Start")
end

function Camera_Path_Reached_Knot()
   -- start the game proper if the path camera finishes
   knot = GetData("Camera.Path.Knot")
   if knot == "OrbitStart" then
      start()
   end
end    

function Camera_Path_Stopped()
  SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")
   -- start the game proper if the camera is interupted
   start()
end

function start()
    SendMessage("EFMV.End")
    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    StartFirstTurn()
end


function SetupWormsAndTeams()

    GM = QueryContainer("GM.GameInitData")
    -- Activate Team 0
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock) -- must close the container ASAP

    -- Worm 0, Team 0
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 1
    worm.Spawn = "spawn1"
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 
 
    SendMessage("WormManager.Reinitialise")

end

function SetupInventories()
    -- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.SuperSheep = -1
    CloseContainer(lock) -- must close the container ASAP
    
    lock, weapon = EditContainer("kWeaponSuperSheep")
    weapon.LifeTime = -1
    CloseContainer(lock)

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   
end

function SelectRandomWind()
   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", 0.1*MaxWind)

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", 3.3) 
end


function Crate_Collected()
    SetData("CommentaryPanel.Comment", "missrum.game5")
    SendMessage("CommentaryPanel.ScriptText") 
    MakeNewCrate()
end

function Crate_Destroyed()

    AddTime = 1
    MakeNewCrate()
end

-- When MakeNewCrate is called It runs through this below and adds 1 each time so it knows which crate it is on

function MakeNewCrate()

    if EndGame == 0 then
        if AddTime == 0 then
            RoundTimeRemaining = GetData("RoundTimeRemaining")
            SetData("RoundTimeRemaining", RoundTimeRemaining + Time)
        end
    end

    if NewCrate == 1 then
        SetData("Crate.Spawn", "crate1")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 1)
        SetData("Crate.Scale", 4)
        SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
	SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 2 then
   	SetData("Crate.Spawn", "crate2")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 2)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 3 then  
        SetData("Crate.Spawn", "crate3")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 3)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 4 then
        SetData("Crate.Spawn", "crate4")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 4)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")
        
    elseif NewCrate == 5 then
   	SetData("Crate.Spawn", "crate5")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 5)
	SetData("Crate.FallSpeed", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 6 then
   	SetData("Crate.Spawn", "crate6")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 6)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 7 then
        SetData("Crate.Spawn", "crate7")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 7)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
	SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 8 then
        SetData("Crate.Spawn", "crate8")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 8)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 9 then
        SetData("Crate.Spawn", "crate9")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 9)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 10 then
        SetData("Crate.Spawn", "crate10")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 10)
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 11 then
        SetData("Crate.Spawn", "crate11")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 11)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")
        
    elseif NewCrate == 12 then
        SetData("Crate.Spawn", "crate12")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 12)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")
      
    elseif NewCrate == 13 then
        SetData("Crate.Spawn", "crate13")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 13)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 14 then
        SetData("Crate.Spawn", "crate14")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 14)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 15 then
        SetData("Crate.Spawn", "crate15")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 15)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 16 then
        SetData("Crate.Spawn", "crate16")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 16)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 17 then
        SetData("Crate.Spawn", "crate17")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 17)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
	SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")
      
    elseif NewCrate == 18 then
        SetData("Crate.Spawn", "crate18")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 18)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
   	SendMessage("GameLogic.CreateCrate")
    
    elseif NewCrate == 19 then
	SetData("Crate.Spawn", "crate19")
        SetData("Crate.Type", "Target")
   	SetData("Crate.Index", 19)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)   
        SetData("Crate.Scale", 4)
	SendMessage("GameLogic.CreateCrate")
        
        if Time > 1000 then
            Time = Time - 1000
        end
   	NewCrate = 0 -- THIS IS WHERE IT SHOULD REPEAT
    end

    AddTime = 0
    NewCrate = NewCrate + 1
   
end


function Worm_Died()
    deadWorm = GetData("DeadWorm.Id")
    
    if deadWorm == 0 then
	    SetData("CommentaryPanel.Comment", "Chall.Generic.Lose1")
	    SendMessage("CommentaryPanel.ScriptText") 
            Switch = 1
    end
end
