-- Apple Core Island: The player must collect the crate in the middle of the landscape
-- guarded by the CPU Worm.  
-- * The player must get at least two of their Worms across to the island in the middle
--   of the landscape.  By standing a Worm on top of another Worm's head the player should be
--   able to backflip up and reach the crate.
-- ! This mission needs text finalising in main file and translation.
-- ! This mission needs some sort of intro with camera fly-bys.
-- ! Replace the "Grenade" in the crate with the Ming Vase (or something similar) when available.
-- ! The CPU skill level should be set to fairly high.
-- ! This mission landscape needs to have particle effects added.
-- ! This mission needs Wormselect x 3 adding to the human players inventory!

function Initialise()
--QA times still need adding...
    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 3
    goldtime = (60 * 1000) * 2

    SetData("Particle.DetailObject", "Particle_Bird")
    SetData("Particle.Name", "Part_BirdSky")
    SendMessage("Particle.NewEmitter")

    SetData("Mine.DudProbabilty", 0.0)
    SetData("Mine.MinFuse", 3000)
    SetData("Mine.MaxFuse", 3000)
    SetData("Jetpack.InitFuel", 1500)
    SendMessage("EFMV.Start")

    SendMessage("GameLogic.PlaceObjects")
    SendMessage("GameLogic.ChangeWind")

    SetData("Crate.Spawn", "Donkey")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponConcreteDonkey")
    SetData("Crate.TeamDestructible", 0)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Pushable", 0)
    SetData("Crate.TeamCollectable", 0)
    SetData("Crate.Index", 100)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "KJetpack2")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityJetpack")
    SetData("Crate.TeamDestructible", 0)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Pushable", 0)
    SetData("Crate.TeamCollectable", 0)
    SetData("Crate.Index", 2)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Trigger.Spawn", "ProtectCrate")
    SetData("Trigger.Radius", 50)
    SetData("Trigger.Index", 10)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "ProtectWorms")
    SetData("Trigger.Radius", 140)
    SetData("Trigger.Index", 10)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")

    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")
    
    SetData("TurnTime", 30000)
    SetData("HotSeatTime", 5000)
    SetData("RoundTime", 0)
    
    SetData("HUD.Clock.DisplayRoundTime", 0)
   
    SetupWormsAndTeams()
    SetupInventories()
    
    deadhuman = 0
    CameraFly = 1
    WhatTurn = 0
    PID1 = 0
    MessagesOff = 0
    Switch = 0
    
    Sparkle_Particles()
    SlowDollyUp()
end


function Sparkle_Particles()
    SetData("Particle.DetailObject", "sparkle1")
    SetData("Particle.Name", "Part_StarBridge")
    SendMessage("Particle.NewEmitter")
    PID1 = GetData("Particle.Handle")    
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        SendMessage("Commentary.Clear")
        SendMessage("EFMV.End")
        CameraFly = 0
        CancelTimer(CamLoop)
        StartFirstTurn()
    end
end

function CameraFinished()
    SendMessage("EFMV.End")
    CameraFly = 0
    StartFirstTurn()
end

function SlowDollyUp()
    SetData("Camera.Path.Knots.Position", "SlowDollyUpCam,SlowDollyUpCam2")
    SetData("Camera.Path.Knots.LookAt", "SlowDollyUpLook")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Scene", 5000)
end

function Scene()
    SetData("Camera.Path.Knots.Position", "SceneCam,SceneCam2")
    SetData("Camera.Path.Knots.LookAt", "SceneCentre")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("LookAtCore", 5000)
end

function LookAtCore()
    SetData("Camera.Path.Knots.Position", "LookAtCoreCam,LookAtCoreCam2")
    SetData("Camera.Path.Knots.LookAt", "LookAtCoreLook")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("ScaleCore", 4000)
end

function ScaleCore()
    SetData("CommentaryPanel.Comment", "Miss.Apple.game1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Apple.game2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "ScaleCoreCam,ScaleCoreCam2")
    SetData("Camera.Path.Knots.LookAt", "ScaleCoreLook,ScaleCoreLook2")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",500) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Worm1Look", 5000)
end

function Worm1Look()
    SetData("CommentaryPanel.Comment", "MissAnt.game2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Worm1Cam")
    SetData("Camera.Path.Knots.LookAt", "Worm1Look")
    SetData("Camera.Path.Steps.Position",0)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Worm2Look", 2500)
    
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Smug2")
    SendIntMessage("Worm.QueueAnim", 0)
end

function Worm2Look()
    SetData("Camera.Path.Knots.Position", "Worm2Cam")
    SetData("Camera.Path.Knots.LookAt", "Worm2Look")
    SetData("Camera.Path.Steps.Position",0)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Worm3Look", 2500)
    
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Happy2")
    SendIntMessage("Worm.QueueAnim", 1)
end

function Worm3Look()
    SetData("Camera.Path.Knots.Position", "Worm3Cam")
    SetData("Camera.Path.Knots.LookAt", "Worm3Look")
    SetData("Camera.Path.Steps.Position",0)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("LookCrate", 2500)
    
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Salute")
    SendIntMessage("Worm.QueueAnim", 2)
end

function LookCrate()
    SetData("CommentaryPanel.Comment", "Miss.Apple.game5")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "CrateCam,CrateCam2")
    SetData("Camera.Path.Knots.LookAt", "CrateLook")
    SetData("Camera.Path.Steps.Position",700)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("LookPack", 5000)
end

function LookPack()
    SetData("CommentaryPanel.Comment", "MissCrate.game1")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "Pack2Cam,Pack2Cam2")
    SetData("Camera.Path.Knots.LookAt", "Pack2Look")
    SetData("Camera.Path.Steps.Position",650)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("CameraFinished", 3500)
end
-- cameras end here

function StartFirstTurn()
    SetData("CommentaryPanel.Comment", "Miss.Apple.game6")
    SendMessage("CommentaryPanel.ScriptText")

   WaitUntilNoActivity = false
   SendMessage("Timer.StartGame")
   StartTurn()
end

function TurnStarted()
    if MessagesOff == 0 then
        WhatTurn = WhatTurn + 1
        if WhatTurn == 5 then
            SetData("CommentaryPanel.Comment", "Miss.Apple.warning")
            SendMessage("CommentaryPanel.ScriptText")
            lock, inventory = EditContainer("Inventory.Team01") 
            inventory.Grenade = -1
            CloseContainer(lock)
        end
    
        if WhatTurn == 7 then
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Miss.Apple.hint1")
            SendMessage("CommentaryPanel.ScriptText")
        end
        
        if WhatTurn == 9 then
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Miss.Apple.hint2")
            SendMessage("CommentaryPanel.ScriptText")
        end
    end
    SelectRandomWind()
    checkteam()
end

function CheckOneTeamVictory()
    TeamCount = GetData("TeamCount")
    WhichTeam = GetData("SurvivingTeamIndex")
    
    if TeamCount == 0 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    else
        StartTurn()
    end
end

function FailureMessages()
    SendMessage("Commentary.Clear")
    
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end

function Crate_Collected()
    CrateNumber = GetData("Crate.Index")
    if CrateNumber == 1 then
        SetData("Crate.Spawn", "KJetpack2")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kUtilityJetpack")
        SetData("Crate.TeamDestructible", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamCollectable", 0)
        SetData("Crate.Index", 2)
        SendMessage("GameLogic.CreateCrate")
        PauseGame()
        Pack2Cam()
    elseif CrateNumber == 2 then
        SetData("Crate.Spawn", "KJetpack3")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kUtilityJetpack")
        SetData("Crate.TeamDestructible", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamCollectable", 0)
        SetData("Crate.Index", 3)
        SendMessage("GameLogic.CreateCrate")
        PauseGame()
        Pack3Cam()
    elseif CrateNumber == 3 then
        SetData("Crate.Spawn", "KJetpack4")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kUtilityJetpack")
        SetData("Crate.TeamDestructible", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamCollectable", 0)
        SetData("Crate.Index", 4)
        SendMessage("GameLogic.CreateCrate")
        PauseGame()
        Pack4Cam()
    elseif CrateNumber == 4 then
        SetData("Crate.Spawn", "KJetpack5")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kUtilityJetpack")
        SetData("Crate.TeamDestructible", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamCollectable", 0)
        SetData("Crate.Index", 5)
        SendMessage("GameLogic.CreateCrate")
        PauseGame()
        Pack5Cam()
    elseif CrateNumber == 5 then
        SetData("Crate.Spawn", "KJetpack6")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kUtilityJetpack")
        SetData("Crate.TeamDestructible", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamCollectable", 0)
        SetData("Crate.Index", 6)
        SendMessage("GameLogic.CreateCrate")
        PauseGame()
        Pack6Cam()
    elseif CrateNumber == 6 then
        SetData("Crate.Spawn", "KJetpack1")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kUtilityJetpack")
        SetData("Crate.TeamDestructible", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamCollectable", 0)
        SetData("Crate.Index", 1)
        SendMessage("GameLogic.CreateCrate")
        PauseGame()
        Pack1Cam()
    elseif CrateNumber == 100 then
        SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")
        
        SetData("CommentaryPanel.Comment", "Miss.Apple.success")
        SendMessage("CommentaryPanel.ScriptText")
        SendIntMessage("Particle.DeleteEmitter", PID1)
        endmissionsuccess()
    end
end

function Pack1Cam()
    SetData("Camera.Path.Knots.Position", "Pack1Cam,Pack1Cam2")
    SetData("Camera.Path.Knots.LookAt", "Pack1Look")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",0)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("ResumeGame", 2500)
end

function Pack2Cam()
    SetData("Camera.Path.Knots.Position", "Pack2Cam,Pack2Cam2")
    SetData("Camera.Path.Knots.LookAt", "Pack2Look")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",0)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("ResumeGame", 2500)
end

function Pack3Cam()
    SetData("Camera.Path.Knots.Position", "Pack3Cam,Pack3Cam2")
    SetData("Camera.Path.Knots.LookAt", "Pack3Look")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",0)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("ResumeGame", 2500)
end

function Pack4Cam()
    SetData("Camera.Path.Knots.Position", "Pack4Cam,Pack4Cam2")
    SetData("Camera.Path.Knots.LookAt", "Pack4Look")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",0)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("ResumeGame", 2500)
end

function Pack5Cam()
    SetData("Camera.Path.Knots.Position", "Pack5Cam,Pack5Cam2")
    SetData("Camera.Path.Knots.LookAt", "Pack5Look")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",0)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("ResumeGame", 2500)
end

function Pack6Cam()
    SetData("Camera.Path.Knots.Position", "Pack6Cam,Pack6Cam2")
    SetData("Camera.Path.Knots.LookAt", "Pack6Look")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",0)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("ResumeGame", 2500)
end

function PauseGame()
    SendMessage("EFMV.Start")
    SendMessage("GameLogic.RoundTime.Pause")
    SendMessage("GameLogic.TurnTime.Pause")
    SendMessage("GameLogic.PauseGame")
    SetData("GameLogic.ArtilleryMode", 1)
end

function ResumeGame()
    SendMessage("GameLogic.RoundTime.Resume")
    SendMessage("GameLogic.TurnTime.Resume")
    SendMessage("GameLogic.ResumeGame")
    SendMessage("EFMV.End")
    SetData("GameLogic.ArtilleryMode", 0)
    SendMessage("Camera.SetDefault")
end

function Crate_Destroyed()
    CrateNumber = GetData("Crate.Index")    
    if CrateNumber == 100 then
        SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")

        SendIntMessage("Particle.DeleteEmitter", PID1)
        SetData("CommentaryPanel.Comment", "Miss.Showdown.Failed")
        SendMessage("CommentaryPanel.ScriptText")
        endmissionfail()
    end
end

function endmissionsuccess()

    Result()

    SetData("CommentaryPanel.Comment", "Miss.generic.success")
    SendMessage("CommentaryPanel.ScriptText")
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3                
                Key,Lock = EditContainer("L.L.Apple")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Apple")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

function endmissionfail()
    if Switch == 0 then
        SetData("CommentaryPanel.Comment", "Miss.generic.fail")
        SendMessage("CommentaryPanel.ScriptText")
        SendMessage("GameLogic.Mission.Failure")
        Switch = 1
    end
end

function checkteam()
    Worm = GetData("ActiveWormIndex")--bm1 check is correct
    if Worm == 3 then
        stopteam()
    end
end
    
function stopteam()
    SetData("GameLogic.ArtilleryMode", 1)
end

function TurnEnded()
    SetData("GameLogic.ArtilleryMode", 0)
    CheckOneTeamVictory()
end 

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    
    lock, team = EditContainer("Team.Data00")
    team.Active = true
    team.Name = GM.T1_Name
    team.TeamColour = 0
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    CloseContainer(lock)
    
    lock, team = EditContainer("Team.Data01")
    team.Active = true
    team.IsAIControlled = true
    team.Name = "Pirates"
    team.TeamColour = 1
    team.FlagGfxName = "94"
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00")
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm1"
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GM.T1_W2_Name
    worm.Spawn = "HumanWorm2"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = GM.T1_W3_Name
    worm.Spawn = "HumanWorm3"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03") 
    worm.Name = "Old Sea Dog"
    worm.Spawn = "CPUWorm1"
    worm.TeamIndex = 1
    worm.SfxBankName = "Pirate"
    CloseContainer(lock)
    CopyContainer("AIParams.CPU4", "AIParams.Worm03")
    lock, worm = EditContainer("AIParams.Worm03") 
    worm.ForbidShotsWhenMightAffectAITrigger = 1
    CloseContainer(lock) 

    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04") 
    worm.Name = "Cut Throat Kim"
    worm.Spawn = "CPUWormA"
    worm.TeamIndex = 1
    worm.SfxBankName = "Pirate"
    CloseContainer(lock)
    CopyContainer("AIParams.CPU2", "AIParams.Worm04")

    CopyContainer("Worm.Data00", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05") 
    worm.Name = "Scurvy Sue"
    worm.Spawn = "CPUWormB"
    worm.TeamIndex = 1
    worm.SfxBankName = "Pirate"
    CloseContainer(lock)
    CopyContainer("AIParams.CPU2", "AIParams.Worm05")
    
    CopyContainer("Worm.Data00", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06") 
    worm.Name = "Eye-Patch Ian"
    worm.Spawn = "CPUWormC"
    worm.TeamIndex = 1
    worm.SfxBankName = "Pirate"
    CloseContainer(lock)
    CopyContainer("AIParams.CPU2", "AIParams.Worm06")
    
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Parachute = 0
    inventory.Prod = -1
    inventory.FirePunch = 2
    inventory.Shotgun = 2
    inventory.Freeze = 1
    inventory.SkipGo = -1
    CloseContainer(lock)
   
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.FirePunch = -1
    inventory.Shotgun = -1
    inventory.SkipGo = -1
    CloseContainer(lock)
end
