
-- Attract mode script

function Initialise()

   -- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    
    SendMessage("GameLogic.PlaceObjects")

    SetupWormsAndTeams()
    SetupInventories()

    SetData("RoundTime", 5*60*1000)
    SetData("Camera.StartOfTurnCamera", "Default")

    StartFirstTurn()
   
end




function SetupWormsAndTeams()

   local languageString = "Classic"
   -- note capitalisation of "SAVE", lower case exists but is a string and may not be being updated
   local languageNum = GetData("SAVE.Language") 
   if languageNum==3 then
      languageString = "French"
   elseif languageNum==4 then
      languageString = "German"
   elseif languageNum==5 then
      languageString = "Italian"
   elseif languageNum==9 then
      languageString = "Spanish"
   end


   -- Activate Team 0
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
   team.Name = "Red Team"
   team.TeamColour = 0
   team.IsAIControlled = true
   team.Skill = 3
   team.GraveIndex = 4
   team.FlagGfxName = 94
   CloseContainer(lock) -- must close the container ASAP
   
   -- Activate Team 1
   lock, team = EditContainer("Team.Data01") 
   team.Active = true
   team.Name = "Blue Team"
   team.TeamColour = 1
   team.IsAIControlled = true
   team.Skill = 3
   team.GraveIndex = 5
   team.FlagGfxName = 55
   CloseContainer(lock)

   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
   worm.Name = "Maverick" 
   worm.Energy = 100
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   worm.SfxBankName = languageString
   worm.Spawn = "spawn"
   CloseContainer(lock) 

   -- Worm 1, Team 0
   CopyContainer("Worm.Data00", "Worm.Data01")
   lock, worm = EditContainer("Worm.Data01") 
   worm.Name = "Cougar"
   CloseContainer(lock)

   CopyContainer("Worm.Data00", "Worm.Data02")
   lock, worm = EditContainer("Worm.Data02") 
   worm.Name = "Iceman"
   CloseContainer(lock)

   CopyContainer("Worm.Data00", "Worm.Data03")
   lock, worm = EditContainer("Worm.Data03") 
   worm.Name = "Goose"
   CloseContainer(lock)

   -- Worm 4, Team 1
   CopyContainer("Worm.Data00", "Worm.Data04")
   lock, worm = EditContainer("Worm.Data04")
   worm.Name = "Viper"
   worm.TeamIndex = 1
   CloseContainer(lock)

   CopyContainer("Worm.Data04", "Worm.Data05")
   lock, worm = EditContainer("Worm.Data05") 
   worm.Name = "Jester"
   CloseContainer(lock)

   CopyContainer("Worm.Data04", "Worm.Data06")
   lock, worm = EditContainer("Worm.Data06") 
   worm.Name = "Slider"
   CloseContainer(lock)

   CopyContainer("Worm.Data04", "Worm.Data07")
   lock, worm = EditContainer("Worm.Data07") 
   worm.Name = "Merlin"
   CloseContainer(lock)


   SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
-- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 

    inventory.BaseballBat = 1
    inventory.Bazooka = -1
    inventory.Binoculars = 1
    inventory.Binoculars = 3
    inventory.Dynamite = 1
    inventory.FirePunch = -1
    inventory.Grenade = -1
    inventory.ClusterGrenade = 3
    inventory.HomingMissile = 1
    inventory.Jetpack = 3
    inventory.Landmine = 2
    inventory.Parachute = 4
    inventory.PetrolBomb = 2
    inventory.Prod = -1
    inventory.Sheep = 1
    inventory.Shotgun = 3
    inventory.SkipGo = -1
    inventory.StickyBomb = 1
    inventory.Teleport = 2
    inventory.Uzi = 5  
    CloseContainer(lock) -- must close the container ASAP

    -- Copies this selection into each worm
    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
    CopyContainer("Inventory.Team.Default", "Inventory.Team01")
end



function CheckOneTeamVictory()
   SendMessage("WormManager.GetActiveAlliances")
   AllianceCount = GetData("AllianceCount")
   if AllianceCount < 2 then
      SendMessage("FCS.QuitAttractMode") -- so we return to main menu in front end
   else
      StartTurn()
   end
end


function Timer_GameTimedOut()
   SendMessage("FCS.QuitAttractMode") -- so we return to main menu in front end
end
