
   -- Mission Shuttle

function Initialise()
    bronzetime = (60 * 1000) * 999
    silvertime = 55000
    goldtime = 50000
    water = 0
    turn = 0
    WaterRate = 0
    WaterAddition = 0
    Switch = 0
    WaterRising = true

    camdone =  0
  
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")
  
    SetData("Crate.TrackCam", 0)

    CameraFly = 0
    SendMessage("HUD.HideTurnTime")
    SetData("HUD.Clock.DisplayRoundTime", 0)
  
    SendMessage("EFMV.Start")
    -- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
   
    SetData("Particle.DetailObject", "JET")
    SetData("Particle.Name", "Part_CrockJet")
    SendMessage("Particle.NewEmitter")
 
    SetData("Particle.DetailObject", "JET2")
    SetData("Particle.Name", "Part_CrockJet")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "JET3")
    SetData("Particle.Name", "Part_CrockJet")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "sparkle1")
    SetData("Particle.Name", "Part_StarBridge")
    SendMessage("Particle.NewEmitter")
    PID1 = GetData("Particle.Handle")
 
    --SETS UP TRIGGER FOR 
    SetData("Trigger.Spawn", "AreaClose")
    SetData("Trigger.Radius", 40)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
   
    SetData("Trigger.Spawn", "Area1")
    SetData("Trigger.Radius", 40)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Area3")
    SetData("Trigger.Radius", 40)
    SetData("Trigger.Index", 3)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
   
    SetData("Crate.Spawn", "crate1")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponFirePunch")
    SetData("Crate.Index", 99)
    SetData("Crate.GroundSnap", 1) 
    SendMessage("GameLogic.CreateCrate")
	
    SendMessage("GameLogic.PlaceObjects")
  
    SetData("HotSeatTime", 0) -- no hotseat time
    SetData("RoundTime", 0) -- no Game timer
    SetData("TurnTime", 0) -- no game timer
     
    SetupWormsAndTeams()
    SetupInventories()
    StartGrantCam()
    --StartFirstTurn()
     
    --StartTurn()
    --WaterRise()
  
end

--///////////////////////////////////////////////////////
--//    Raise the water constantly                     //
--///////////////////////////////////////////////////////

function WaterRise()

        if WaterRate == 0 then
            WaterRiseTimer = StartTimer("rise", 250)
            WaterAddition = 0
            
        elseif WaterRate == 1 then
            WaterRiseTimer = StartTimer("rise", 250)
            WaterAddition = 1
    
        elseif WaterRate == 2 then
            WaterRiseTimer = StartTimer("rise", 250)
            WaterAddition = 2
    
        elseif WaterRate == 3 then
            WaterRiseTimer = StartTimer("rise", 250)
            WaterAddition = 3
        end

    
end


function rise() 

   -- stop rising when he dies
   worm = QueryContainer("Worm.Data00") 
   if worm.Energy>0 and Switch == 0 then 
        if WaterAddition == 0 then
        
            water = water + 0.205
            SetData("Water.Level", water)
        
        elseif WaterAddition == 1 then
    
            water = water + 1.04
            SetData("Water.Level", water)        
        
        elseif WaterAddition == 2 then
        
            water = water + 2.2
            SetData("Water.Level", water) 
    
        elseif WaterAddition == 3 then
        
            water = water + 4.253
            SetData("Water.Level", water)        
        
        end
            
        WaterRise()
   end
end


--/////////////////////////////////////////////////////////
--//            Check for the crate being destroy        //
--/////////////////////////////////////////////////////////

function Crate_Destroyed()

    CheckCrate()

end

function Crate_Sunk()

    CheckCrate()

end

function CheckCrate()

    CrateNumber = GetData("Crate.Index")
    
    if CrateNumber == 99 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            SendMessage("Commentary.NoDefault")
            
            SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
            SendMessage("CommentaryPanel.ScriptText")
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end
end

--////////////////////////////////////////////////////////
--//            Start the first turn                    //
--////////////////////////////////////////////////////////

function StartFirstTurn()
    WaitUntilNoActivity = false
    
    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    SendMessage("EFMV.End")	
    SendMessage("Timer.StartGame")
    
    StartTurn()
end

--////////////////////////////////////////////////////////
--//            Check at the turn end                   //
--////////////////////////////////////////////////////////

function TurnEnded()
    SendMessage("WormManager.GetActiveWormCount")
    WormCount = GetData("WormCount")
    
    if WormCount == 0 then
        -- all the worms have just snuffed it
        if Switch == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    else
        -- still at least some worms left
        StartTurn()
    end
end

--////////////////////////////////////////////////////////
--//    CLOSE TO TOP OF SHUTTLE                         //
--////////////////////////////////////////////////////////

function Trigger_Collected()
    TriggerIndex = GetData("Trigger.Index")
        
    if TriggerIndex == 1 then
        SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")
        
        SetData("CommentaryPanel.Comment", "Chall.Homing.WellDone")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Boldly.NEW.game5")
        SendMessage("CommentaryPanel.ScriptText")
        
        WaterRate = 2
        
    elseif TriggerIndex == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Boldly.NEW.game5")
        SendMessage("CommentaryPanel.ScriptText")
        
        WaterRate = 1
    
    elseif TriggerIndex == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Boldly.NEW.game5")
        SendMessage("CommentaryPanel.ScriptText")
        WaterRate = 3
    end
    
    
end

--////////////////////////////////////////////////////////
--//    Setup worms and their inventories               //
--////////////////////////////////////////////////////////
	
function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    -- Activate Team 0
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock) -- must close the container ASAP

    -- Worm 0, Team 0
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn1"
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    -- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.SkipGo = 0
    inventory.Surrender = 0

    CloseContainer(lock) -- must close the container ASAP

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
end

--////////////////////////////////////////////////////////////////
--//            Check for crate collected                       //
--////////////////////////////////////////////////////////////////

function Crate_Collected()

    -- Get the crate index
    CrateNumber = GetData("Crate.Index")
    
    if CrateNumber == 99 then
        SendIntMessage("Particle.DeleteEmitter", PID1)
        SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")
        
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")
        
        Switch = 1
        WONWON()
    -- PC: changed GetActiveTeamIndex to a different call/data value.. to catch some script errors.
    -- to get the "current team" use this call (GetCurrentTeamIndex)
    end
end


--////////////////////////////////////////////////////////////////
--//            End game                                        //
--////////////////////////////////////////////////////////////////

function WONWON()

    Result()

end

--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        Key,Lock = EditContainer("L.Sch.WBnG") --unlock Prototype info in wormapedia 
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName2","L.Sch.WBnG")
        end
        CloseContainer(Key)
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.P.Proto") --unlock Prototype info in wormapedia 
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.P.Proto")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end


--////////////////////////////////////////////////////////////////
--//                    Camera code                             //
--////////////////////////////////////////////////////////////////

function StartGrantCam()

    CameraFly = 1
    
    SetData("Camera.Path.Knots.Position", "Cam13")
    SetData("Camera.Path.Knots.LookAt", "Look1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Tension.Position", -0.6)     
    SendMessage("Camera.Path.Start")    
    
    SetData("CommentaryPanel.Comment", "Miss.BoldlyNEW.game1")
    SendMessage("CommentaryPanel.ScriptText")
    
    
    CamLoop = StartTimer("cameraworm", 4550)

end

function cameraworm()
    SetData("CommentaryPanel.Comment", "Miss.BoldlyNEW.game2")
    SendMessage("CommentaryPanel.ScriptText")

    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Taunt2")
    SendIntMessage("Worm.QueueAnim", 0)
    
    SetData("Camera.Path.Knots.Position", "wormcam1")
    SetData("Camera.Path.Knots.LookAt", "wormlook1")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",150)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    
    CamLoop = StartTimer("camera2", 4000)
end


function camera2()
    SetData("CommentaryPanel.Comment", "Miss.BoldlyNEW.game3")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "Cam1,Cam4,Cam7,Cam10, Cam13, OrbitStart")
    SetData("Camera.Path.Knots.LookAt", "Look1, Look2")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.5)
    SetData("Camera.Path.Steps.Position",250)
    SetData("Camera.Path.Steps.LookAt",1000)     
    SendMessage("Camera.Path.Start")
    

end



function camera3()
    SetData("CommentaryPanel.Comment", "Miss.BoldlyNEW.game4")
    SendMessage("CommentaryPanel.ScriptText")

    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Scared1")
    SendIntMessage("Worm.QueueAnim", 0)
    
    SetData("Camera.Path.Knots.Position", "wormcam2")
    SetData("Camera.Path.Knots.LookAt", "wormlook2")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",400)  
    SendMessage("Camera.Path.Start")
    
    StartTimer("startt", 3000)
end

function Camera_Path_Reached_Knot()

    knot = GetData("Camera.Path.Knot")


    if knot == "OrbitStart" then
        
        camera3()
        
    end
    
end    

function Camera_Path_Stopped()
    if CameraFly == 1 then
        CameraFly = 0
        
        SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")
        
        WaterRise()

        CancelTimer(CamLoop)
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end
        
        startt()
    end
end

function startt()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    SendMessage("EFMV.End")
    
    camdone =  1
    StartFirstTurn()
    WaterRise()
    
end


--/////////////////////////////////////////////////////////
--// pick from a bunch of message at the end of the game //
--/////////////////////////////////////////////////////////


function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
    
end

function SuccessMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end

end






