-- basic script showing the crate functionality

function Initialise()
   SendMessage("GameLogic.PlaceObjects")
   SendMessage("GameLogic.ChangeWind")

   -- Create a crate...
   -- first set the spawn point   
   SetData("Crate.Spawn", "CrateSpawn1")
   
   -- now set the crate type and contents
   -- note: the crate type name is
   --       not case sensitive
   SetData("Crate.Type", "Health")
   SetData("Crate.NumContents", 25)
   SetData("Crate.Contents", "kWeaponUzi")
   
   -- now set the crate number
   -- these do not have to be unique
   SetData("Crate.Index", 1)
   
   -- finally send the creation message
   SendMessage("GameLogic.CreateCrate")
   
   -- note: if we now call create crate
   -- again we will create another crate,
   -- of the same type, index and at
   -- the same location.
   
   -- for this I will only change
   -- the position and type (not the index)
   SetData("Crate.Spawn", "SomewhereElse")
   SetData("Crate.Type", "Target")
   SendMessage("GameLogic.CreateCrate")
   
   -- creating a weapon crate
   SetData("Crate.Spawn", "CrateSpawn2")
   SetData("Crate.Type", "Weapon")
   SetData("Crate.NumContents", 1)
   SetData("Crate.Contents", "kWeaponClusterBomb")
   SendMessage("GameLogic.CreateCrate")
   
   -- creating a utility crate
   SetData("Crate.Spawn", "CrateSpawn3")
   SetData("Crate.Type", "Utility")
   SetData("Crate.Contents", "kUtilityDoubleTurnTime")
   SetData("Crate.NumContents", 1)
   SetData("Crate.GroundSnap", 1)
   SendMessage("GameLogic.CreateCrate")
   
   StartFirstTurn()
end

-- this is the crate collection function
function Crate_Collected()
    -- CrateIndex is the value set for CrateIndex when the crate was created
    -- you can use this number to check which crate was collected
    CrateNumber = GetData("Crate.Index")
end

-- this is the crate destroyed function
function Crate_Destroyed()
    -- Get the crate index
    CrateNumber = GetData("Crate.Index")
end
