-- Landscape: On the steps platform that leads to the house object the little right angled joins can be seen.
-- Landscape: The first step on the above mentioned platform could be moved a little closer in so that the Worm
--            doesn't fall down the gap.
-- Landscape: On the islands surrounding the main centre island it would be an idea to place objects that could be
--            used for cover.  Anything at all, large stones and such spring to mind.

-- ! Bug with the game means that adding Girders to the player controlled Worm's weapon inventory means that the Worm
--   cannot move about the landscape at all, even after selecting another weapon
-- ! Uzi is screwed in this game, bats the Worm all about the play area.

function Initialise()
-- Still need QA times...
    bronzetime = (60 * 1000) * 999
    silvertime = 850000
    goldtime = 800000
    
    SendMessage("Commentary.NoDefault")
    SendMessage("EFMV.Start")
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")
    
    SetData("Trigger.Spawn", "ProtectTrig")
    SetData("Trigger.Radius", 100)
    SetData("Trigger.Index", 50)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "SmokeDet")
    SetData("Trigger.Radius", 20)
    SetData("Trigger.Index", 51)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",-1)
    SetData("Trigger.AffectsAI",0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TractorDet")
    SetData("Trigger.Radius", 20)
    SetData("Trigger.Index", 52)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",-1)
    SetData("Trigger.AffectsAI",0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Crate.Spawn", "OnlyChutes")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 2)
    SetData("Crate.Contents", "kUtilityParachute")
    SetData("Crate.Pushable", 0)
    SetData("Crate.TeamDestructible", -1)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("TurnTime", 45000)
    SetData("HotSeatTime", 3000)
    SetData("RoundTime", 0)
    SetData("HUD.Clock.DisplayRoundTime", 0)
    
    WeaponCrate = 1
    HealthCrate = 101
    CollectedBanana = 1
    DeadCPU = 0
    deadhuman = 0
    CameraFly = 1
    deadworm = 10
    Switch = 0
    
    SpawnWeaponCrate()
    SpawnHealthCrate()
    StartParticle()
    SetupWormsAndTeams()
    SetupInventories()
    
    SetData("GameLogic.WeaponName", "kUtilityFreeze")
    SendMessage("GameLogic.RequestWeaponIndex")
    WIndex = GetData("GameLogic.WeaponIndex")
    lock, worm = EditContainer("Worm.Data00")
    worm.WeaponIndex = WIndex
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data01")
    worm.WeaponIndex = WIndex
    CloseContainer(lock)
    
    First()
end

function StartParticle()
    SetData("Particle.DetailObject", "Part_RadarRings")
    SetData("Particle.Name", "Part_RadarRings")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Part_BFlies")
    SetData("Particle.Name", "Part_Butterfly")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Part_BFlies2")
    SetData("Particle.Name", "Part_Butterfly")
    SendMessage("Particle.NewEmitter")

    SetData("Particle.DetailObject", "Part_TractorSmoke")
    SetData("Particle.Name", "Part_Steamplume")
    SendMessage("Particle.NewEmitter")
    ids2 = GetData("Particle.Handle")
    
    ChimneySmoke()
end

function ChimneySmoke()
    SetData("Particle.DetailObject", "ChimneySmoke")
    SetData("Particle.Name", "ParticleSmokePlume")
    SendMessage("Particle.NewEmitter")
    ids1 = GetData("Particle.Handle")
    ChimSmokeTime = StartTimer("ChimneySmoke", 20000)
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        SendMessage("Commentary.Clear")
        SendMessage("EFMV.End")
        CameraFly = 0
        CancelTimer(CamLoop)
        StartFirstTurn()
    end
end

function CameraFinished()
    SendMessage("EFMV.End")
    CameraFly = 0
    StartFirstTurn()
end

function First()
    SetData("Camera.Path.Knots.Position", "FirstCam,FirstCam2")
    SetData("Camera.Path.Knots.LookAt", "FirstLook,FirstLook2")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Second", 4000)
end

function Second()
    SetData("Camera.Path.Knots.Position", "SecondCam,SecondCam2")
    SetData("Camera.Path.Knots.LookAt", "SecondLook")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",500) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line1", 3000)
end

function Line1()
    SetData("CommentaryPanel.Comment", "Miss.Crop.game1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line1Cam,Line1Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line1Look")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line2", 5000)
    StartTimer("Line1Anim", 3300)
end

function Line1Anim()
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Scowl2")
    SendIntMessage("Worm.QueueAnim", 2)
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 2)
end

function Line2()
    SetData("CommentaryPanel.Comment", "Miss.Crop.game2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line2Cam,Line2Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line2Look")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",500) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line3", 4000)
end

function Line3()
    SetData("CommentaryPanel.Comment", "Miss.Crop.game3")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line3Cam,Line3Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line3Look")
    SetData("Camera.Path.Steps.Position",330)
    SetData("Camera.Path.Steps.LookAt",330) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line4", 3000)
end

function Line4()
    SetData("CommentaryPanel.Comment", "Miss.Crop.game4")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line4Cam,Line4Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line4Look,Line4Look2")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",500) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line5", 3000)
end

function Line5()
    SetData("CommentaryPanel.Comment", "Miss.Crop.game5")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line5Cam")
    SetData("Camera.Path.Knots.LookAt", "Line5Look")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line6", 2500)
    
    SendIntMessage("Worm.ResetAnim", 4)
    SetData("Worm.ScriptAnim", "Wave_Right")
    SendIntMessage("Worm.QueueAnim", 4)
end

function Line6()
    SetData("CommentaryPanel.Comment", "Miss.Crop.game6")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line6Cam,Line6Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line6Look")
    SetData("Camera.Path.Steps.Position",400)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("CameraFinished", 2500)
    
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 0)
end
-- cameras end here
function Crate_Collected()
    CrateNumber = GetData("Crate.Index")
    if CrateNumber == WeaponCrate then
        WeaponCrate = WeaponCrate + 1
        if WeaponCrate == 14 then
            WeaponCrate = 1
            SpawnBanana()
        end
        SpawnWeaponCrate()
    elseif CrateNumber == HealthCrate then
        HealthCrate = HealthCrate + 1
        if HealthCrate == 104 then
            HealthCrate = 101
        end
        SpawnHealthCrate()
    elseif CrateNumber == 105 then
        CollectedBanana = 1
    end
end

function Crate_Destroyed()
    CrateNumber = GetData("Crate.Index")
    if CrateNumber == WeaponCrate then
        WeaponCrate = WeaponCrate + 1
        if WeaponCrate == 14 then
            WeaponCrate = 1
            SpawnBanana()
        end
        SpawnWeaponCrate()
    elseif CrateNumber == HealthCrate then
        HealthCrate = HealthCrate + 1
        if HealthCrate == 104 then
            HealthCrate = 101
        end
        SpawnHealthCrate()
    elseif CrateNumber == 105 then
        CollectedBanana = 1
    end
end

function Crate_Sunk()
    CrateNumber = GetData("Crate.Index")
    if CrateNumber == WeaponCrate then
        WeaponCrate = WeaponCrate + 1
        if WeaponCrate == 14 then
            WeaponCrate = 1
            SpawnBanana()
        end
        SpawnWeaponCrate()
    elseif CrateNumber == HealthCrate then
        HealthCrate = HealthCrate + 1
        if HealthCrate == 104 then
            HealthCrate = 101
        end
        SpawnHealthCrate()
    elseif CrateNumber == 105 then
        CollectedBanana = 1
    end
end

function Trigger_Destroyed()
    TriggerIndex = GetData("Trigger.Index")
    if TriggerIndex == 51 then
        CancelTimer(ChimSmokeTime)
        SendIntMessage("Particle.DeleteEmitter",ids1)
    elseif TriggerIndex == 52 then
        SendIntMessage("Particle.DeleteEmitter",ids2)
    end
end

function SpawnHealthCrate()
    if HealthCrate == 101 then
        SetData("Crate.Spawn", "Health1")
        SetData("Crate.Type", "Health")
        SetData("Crate.NumContents", 30)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 101)
        SendMessage("GameLogic.CreateCrate")
    elseif HealthCrate == 102 then
        SetData("Crate.Spawn", "Health2")
        SetData("Crate.Type", "Health")
        SetData("Crate.NumContents", 30)
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 102)
        SendMessage("GameLogic.CreateCrate")
    elseif HealthCrate == 103 then
        SetData("Crate.Spawn", "Health3")
        SetData("Crate.Type", "Health")
        SetData("Crate.NumContents", 30)
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 103)
        SendMessage("GameLogic.CreateCrate")
    end
end

function SpawnWeaponCrate()
    if WeaponCrate == 1 then
        SetData("Crate.Spawn", "Bazooka1")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 1)
        SendMessage("GameLogic.CreateCrate")
    elseif WeaponCrate == 2 then
        SetData("Crate.Spawn", "Grenade2")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponGrenade")
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 2)
        SendMessage("GameLogic.CreateCrate")
    elseif WeaponCrate == 3 then
        SetData("Crate.Spawn", "Bazooka3")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 3)
        SendMessage("GameLogic.CreateCrate")
    elseif WeaponCrate == 4 then
        SetData("Crate.Spawn", "Grenade4")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponGrenade")
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 4)
        SendMessage("GameLogic.CreateCrate")
    elseif WeaponCrate == 5 then
        SetData("Crate.Spawn", "ClusterGrenade5")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponClusterGrenade")
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 5)
        SendMessage("GameLogic.CreateCrate")
    elseif WeaponCrate == 6 then
        SetData("Crate.Spawn", "Grenade6")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponGrenade")
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 6)
        SendMessage("GameLogic.CreateCrate")
    elseif WeaponCrate == 7 then
        SetData("Crate.Spawn", "Girder7")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kUtilityGirder")
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 7)
        SendMessage("GameLogic.CreateCrate")
    elseif WeaponCrate == 8 then
        SetData("Crate.Spawn", "Bazooka8")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 8)
        SendMessage("GameLogic.CreateCrate")
    elseif WeaponCrate == 9 then
        SetData("Crate.Spawn", "Girder9")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kUtilityGirder")
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 9)
        SendMessage("GameLogic.CreateCrate")
    elseif WeaponCrate == 10 then
        SetData("Crate.Spawn", "ClusterGrenade10")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponGrenade")
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 10)
        SendMessage("GameLogic.CreateCrate")
    elseif WeaponCrate == 11 then
        SetData("Crate.Spawn", "Girder11")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kUtilityGirder")
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 11)
        SendMessage("GameLogic.CreateCrate")
    elseif WeaponCrate == 12 then
        SetData("Crate.Spawn", "Grenade12")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponGrenade")
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 12)
        SendMessage("GameLogic.CreateCrate")
    elseif WeaponCrate == 13 then
        SetData("Crate.Spawn", "Bazooka13")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Pushable", 0)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 13)
        SendMessage("GameLogic.CreateCrate")
    end
end
-- movehere
function SpawnBanana()
    if CollectedBanana == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Crop.game7")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Crate.Spawn", "Banana")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponBananaBomb")
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 105)
        SendMessage("GameLogic.CreateCrate")
        CollectedBanana = 0
    end
end


function CheckOneTeamVictory()

   SendMessage("WormManager.GetActiveTeamCount")
   TeamCount = GetData("TeamCount")
   
    if TeamCount == 0 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
            SendMessage("CommentaryPanel.ScriptText")
            SetData("CommentaryPanel.Comment", "Miss.generic.fail")
            SendMessage("CommentaryPanel.ScriptText")
            endmissionfail()
            Switch = 1
        end
        
    elseif TeamCount == 1 then
      
        SendMessage("WormManager.GetSurvivingTeam")
        TeamLeft = GetData("SurvivingTeamIndex")
        
        if TeamLeft == 1 then   
            -- all the teams have just snuffed it
            if Switch == 0 then
                SendMessage("Commentary.Clear")
                SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
                SendMessage("CommentaryPanel.ScriptText")
                SetData("CommentaryPanel.Comment", "Miss.generic.fail")
                SendMessage("CommentaryPanel.ScriptText")
                endmissionfail()
                Switch = 1
            end
        end
        ----NEEDS RETURNING TO ZERO,.
        if TeamLeft == 0 then  
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Miss.Crop.success")
            SendMessage("CommentaryPanel.ScriptText")
            SetData("CommentaryPanel.Comment", "Miss.generic.success")
            SendMessage("CommentaryPanel.ScriptText")
            endmissionsuccess()
            Switch = 1
        end 

    elseif TeamCount == 2 then
        -- still at least 2 teams left
        StartTurn()
    end
end

function endmissionsuccess()

    Result()

end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()

    SetData("Camera.Path.IgnoreInput", 1)
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1
 
        if timetook < silvertime then
            Movie = 2
            
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.L.Crop")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Crop")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

--/////////////////////////////////////////////////////////////
--/////////////////////////////////////////////////////////////


function endmissionfail()
    SendMessage("GameLogic.Mission.Failure")
end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00")
    team.FlagGfxName = GM.T1_Flag    
    team.Active = true
    team.Name = GM.T1_Name
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock) 

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.IsAIControlled = true
    team.Name = "Space Cadets"
    team.FlagGfxName = "80"
    team.TeamColour = 1
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "HumanWorm1"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01")    
    worm.Active = true
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "HumanWorm2"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02")
    worm.Energy = 80 
    worm.Name = "Blackhole Hooper"
    worm.TeamIndex = 1
    worm.SfxBankName = "Cyberworms"
    worm.Spawn = "CPUWorm1"
    CloseContainer(lock)
    CopyContainer("AIParams.CPU1", "AIParams.Worm02")
    lock, worm = EditContainer("AIParams.Worm02") 
    worm.ForbidShotsWhenMightAffectAITrigger = 1
    CloseContainer(lock) 
    
    CopyContainer("Worm.Data02", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03")
    worm.Energy = 80  
    worm.Name = "Jetpack Johnson"
    worm.Spawn = "CPUWorm2"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm02", "AIParams.Worm03")

    CopyContainer("Worm.Data02", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Energy = 80  
    worm.Name = "Bobby BlastOff"
    worm.Spawn = "CPUWorm3"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm02", "AIParams.Worm04")

    CopyContainer("Worm.Data02", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    worm.Energy = 80  
    worm.Name = "SpaceRanger Robinson"
    worm.Spawn = "CPUWorm4"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm02", "AIParams.Worm05")
    
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Girder = 2
    inventory.Freeze = 2
    inventory.SkipGo = -1
--    inventory.Jetpack = -1
    inventory.Dynamite = -1
    --inventory.Surrender = -1
    CloseContainer(lock)
    
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Bazooka = -1
    inventory.Grenade = -1
    inventory.ClusterGrenade = 5
    inventory.Parachute = 2
    inventory.Shotgun = 4
    inventory.Uzi = 3
    inventory.SkipGo = -1
    --inventory.Surrender = -1
    CloseContainer(lock)
end


function TurnStarted()

    checkteam()
    
end

function checkteam()
-- PC: the current team value is now called CurrentTeamIndex
    Team = GetData("CurrentTeamIndex")
    if Team == 1 then
        SetData("GameLogic.ArtilleryMode", 1)
    else
        SetData("GameLogic.ArtilleryMode", 0)
    end
end




