-- ex8
-- Example of Setting up worms and teams

function Initialise()
   SendMessage("GameLogic.PlaceObjects")
   SendMessage("GameLogic.ChangeWind") 

   SetupWormsAndTeams()
   SetupInventories()

   StartFirstTurn()
end

function SetupWormsAndTeams()

   -- Activate Team 0
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
   team.Name = "Good Guys"
   team.TeamColour = 0
   CloseContainer(lock) -- must close the container ASAP

   -- Activate Team 0
   lock, team = EditContainer("Team.Data01") 
   team.Active = true
   team.Name = "Bad Guys"
   team.TeamColour = 1
   CloseContainer(lock)

   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
   worm.Name = "Jegg"
   worm.Energy = 100
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 

   -- Worm 1, Team 0
   CopyContainer("Worm.Data00", "Worm.Data01")
   lock, worm = EditContainer("Worm.Data01") 
   worm.Name = "Chesh"
   CloseContainer(lock)

   -- Worm 2, Team 0
   CopyContainer("Worm.Data00", "Worm.Data02")
   lock, worm = EditContainer("Worm.Data02") 
   worm.Name = "Bruce"
   CloseContainer(lock)

   -- Worm 3, Team 0
   CopyContainer("Worm.Data00", "Worm.Data03")
   lock, worm = EditContainer("Worm.Data03") 
   worm.Name = "Kel"
   CloseContainer(lock)

   -- Worm 4, Team 1
   CopyContainer("Worm.Data00", "Worm.Data04")
   lock, worm = EditContainer("Worm.Data04") 
   worm.Name = "FuxDeluxe"
   worm.TeamIndex = 1
   CloseContainer(lock)

   -- Worm 5, Team 1
   CopyContainer("Worm.Data04", "Worm.Data05")
   lock, worm = EditContainer("Worm.Data05") 
   worm.Name = "Spadge"
   CloseContainer(lock)

   -- Worm 6, Team 1
   CopyContainer("Worm.Data04", "Worm.Data06")
   lock, worm = EditContainer("Worm.Data06") 
   worm.Name = "Dennis"
   CloseContainer(lock)

   -- Worm 7, Team 1
   CopyContainer("Worm.Data04", "Worm.Data07")
   lock, worm = EditContainer("Worm.Data07") 
   worm.Name = "Oldham"
   CloseContainer(lock)

   SendMessage("WormManager.Reinitialise")

end



function SetupInventories()
   -- sets up a default container and adds our selection to it
   lock, inventory = EditContainer("Inventory.Team.Default") 
   inventory.Bazooka = -1
   inventory.Sheep = -1
   inventory.Airstrike = -1
   CloseContainer(lock) -- must close the container ASAP

   -- Copies this selection into each worm
   CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   CopyContainer("Inventory.Team.Default", "Inventory.Team01")

   -- Sets up some delays
   lock, delays = EditContainer("Inventory.WeaponDelays") 
   delays.Airstrike = 1
   CloseContainer(lock)
end
