
-- ! Mission needs Worm Select.
-- ! Perhaps place worms on second island closer to triggers when they spawn?
-- ! Enemy CPU will need dumming down.
-- ! Playtesting will reveal whether or not these weapon sets are adequate - enemy CPU may want projectiles.
-- ! Landscape will have to be indestructible for the reason that when parts of the land are knocked away the Worms
-- ! will try to spawn in where there is no land, the particle dust will also fly in mid air! :/  This could be 
-- ! gotten around and the landscape could remain destructible but it would require more work (triggers could be
-- ! placed in the spawn areas and if they're destroyed Worms could simply not be allowed to spawn there).
-- ! Text needs to be finalised.
-- ! This mission has problems playing many different commentary texts at the same time.. they confuse a little.
-- ! In last version killing DraculaWorm with Baseball Bat just spawned him back on the landscape.

function Initialise()
--Need QA times:
    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 13.5
    goldtime = (60 * 1000) * 13
    
    SetData("Camera.StartOfTurnCamera","Default")
    SendMessage("Commentary.NoDefault")
    
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SendMessage("GameLogic.PlaceObjects")
    SetData("HUD.Clock.DisplayRoundTime", 0)

    SendMessage("EFMV.Start")
    SetData("Land.Indestructable", 1)
    
    SetData("TurnTime", 45000)
    SetData("HotSeatTime", 5000)
    SetData("RoundTime", 0)

    SetData("Crate.Spawn", "Girder")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityGirder")
    SetData("Crate.Pushable", 0)
    SetData("Crate.TeamDestructible", 10)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Trigger.Spawn", "ProtectCPU")
    SetData("Trigger.Radius", 30)
    SetData("Trigger.Index", 50)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
    
    undead = 0
    baddie = 0
    draculadead = 0
    Vampyr1 = 0
    Vampyr2 = 0
    Vampyr3 = 0
    Vampyr4 = 0
    Vampyr5 = 0
    Vampyr6 = 0
    Vampyr7 = 0
    Vampyr8 = 0
    BatUsed = 0

    CameraFly = 1
    TextControl = 0
    Switch = 0
    
    makeLOCATIONS()

    SetData("Particle.DetailObject", "Part_Ghost")
    SetData("Particle.Name", "Part_Ghost")
    SendMessage("Particle.NewEmitter")
    
    StartTimer("SecondGhost", 2000)
    SelectRandomWind()
    SetupWormsAndTeams()
    SetupInventories()
    PullBackFromScene()
end

function SecondGhost()
    SetData("Particle.DetailObject", "Part_Ghost2")
    SetData("Particle.Name", "Part_Ghost")
    SendMessage("Particle.NewEmitter")
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        SendMessage("Commentary.Clear")
        SendMessage("EFMV.End")
        CameraFly = 0
        CancelTimer(CamLoop)
        StartFirstTurn()
    end
end

function CameraFinished()
    SendMessage("EFMV.End")
    CameraFly = 0
    StartFirstTurn()
end

function TurnStarted()
    TextControl = 0
    
    Team = GetData("CurrentTeamIndex")
    if Team == 1 then
        SetData("GameLogic.ArtilleryMode", 1)
    end
end

function PullBackFromScene()
    SetData("Camera.Path.Knots.Position", "Camera0,Camera0b")
    SetData("Camera.Path.Knots.LookAt", "LookAtPoint0")
    SetData("Camera.Path.Steps.Position",350)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("OneFlyBy", 3000)
end

function OneFlyBy()
    SetData("Camera.Path.Knots.Position", "Camera1,Camera2")
    SetData("Camera.Path.Knots.LookAt", "LookAtPoint1,LookAtPoint2")
    SetData("Camera.Path.Steps.Position",450)
    SetData("Camera.Path.Steps.LookAt",450) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("OneFlyBy2", 3500)
end

function OneFlyBy2()
    SetData("CommentaryPanel.Comment", "Highstakes.Brief1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Camera3,Camera4")
    SetData("Camera.Path.Knots.LookAt", "LookAtPoint3,LookAtPoint4")
    SetData("Camera.Path.Steps.Position",320)
    SetData("Camera.Path.Steps.LookAt",320)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("LookDirectly", 3000)
end

function LookDirectly()
    SetData("CommentaryPanel.Comment", "Highstakes.Brief2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Camera5,Camera5pb")
    SetData("Camera.Path.Knots.LookAt", "LookAtPoint5")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Evil")
    SendIntMessage("Worm.QueueAnim", 3)
    
    CamLoop = StartTimer("SlowZoom", 2500)
end

function SlowZoom()
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Horror")
    SendIntMessage("Worm.QueueAnim", 0)

    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Pray")
    SendIntMessage("Worm.QueueAnim", 1)
    
    SetData("CommentaryPanel.Comment", "Highstakes.Brief3")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Camera6,Camera6b")
    SetData("Camera.Path.Knots.LookAt", "LookAtPoint6")
    SetData("Camera.Path.Steps.Position",320)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("LookDirectly2", 3000)
end

function LookDirectly2()
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Smug2")
    SendIntMessage("Worm.QueueAnim", 2)
    
    SetData("CommentaryPanel.Comment", "Highstakes.Brief4")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Camera8")
    SetData("Camera.Path.Knots.LookAt", "LookAtPoint8")
    SetData("Camera.Path.Steps.Position",0)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("RotateChurch", 3000)
end

function RotateChurch()
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Smile")
    SendIntMessage("Worm.QueueAnim", 3)

    SetData("CommentaryPanel.Comment", "Highstakes.Brief5")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Camera9,Camera9b")
    SetData("Camera.Path.Knots.LookAt", "LookAtPoint9")
    SetData("Camera.Path.Steps.Position",400)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Pan", 3000)
end

function Pan()
    SetData("CommentaryPanel.Comment", "Highstakes.Brief6")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Camera10,Camera11")
    SetData("Camera.Path.Knots.LookAt", "LookAtPoint10,LookAtPoint11")
    SetData("Camera.Path.Steps.Position",400)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("LookDirectly4", 3000)
end

function LookDirectly4()
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Taunt1")
    SendIntMessage("Worm.QueueAnim", 3)

    SetData("CommentaryPanel.Comment", "Highstakes.Brief7")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Camera12")
    SetData("Camera.Path.Knots.LookAt", "LookAtPoint12")
    SetData("Camera.Path.Steps.Position",0)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    
    CamLoop = StartTimer("CameraFinished", 3000)
end

--function StartTurn()
--   done_once_per_turn_functions = false
--   SendMessage("Timer.StartHotSeatTimer")
--   SendMessage("GameLogic.ActivateNextWorm")
--   SendMessage("Weapon.Create")
--   SetWind()
   --TurnStarted()
--   SendMessage("GameLogic.Turn.Started")
--   TurnStarted() -- moved here so TeleportIn camera can override startofturn camera
--   RunAILogic()
--   TextControl = 0
--end
--bm2
function SayEnemyNextTurn()
    if TextControl == 1 then
        SetData("CommentaryPanel.Comment", "Highstakes.7")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

function TurnEnded()
    if draculadead == 1 then
        blankvariables()
    end
    SetData("GameLogic.ArtilleryMode", 0)
    CheckOneTeamVictory()
    
    if Vampyr1 == 4 then
        Vampyr1 = Vampyr1 - 1
    elseif Vampyr1 == 3 then
        Vampyr1 = Vampyr1 - 1
    elseif Vampyr1 == 2 then
        Vampyr1 = Vampyr1 - 1
        TextControl = TextControl + 1
        SayEnemyNextTurn()
    elseif Vampyr1 == 1 then
        SetData("Particle.DetailObject", "Clod1")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        CreateExplosion("Clod1", 0, 0.75, 0, 0, 45)
        StartTimer("respawnbaddie", 500)
    end
    
    if Vampyr2 == 4 then
        Vampyr2 = Vampyr2 - 1
    elseif Vampyr2 == 3 then
        Vampyr2 = Vampyr2 - 1
    elseif Vampyr2 == 2 then
        Vampyr2 = Vampyr2 - 1
        TextControl = TextControl + 1
        SayEnemyNextTurn()
    elseif Vampyr2 == 1 then
        SetData("Particle.DetailObject", "Clod2")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        CreateExplosion("Clod2", 0, 0.75, 0, 0, 45)
        StartTimer("respawnbaddie", 500)
    end
    
    if Vampyr3 == 4 then
        Vampyr3 = Vampyr3 - 1
    elseif Vampyr3 == 3 then
        Vampyr3 = Vampyr3 - 1
    elseif Vampyr3 == 2 then
        Vampyr3 = Vampyr3 - 1
        TextControl = TextControl + 1
        SayEnemyNextTurn()
    elseif Vampyr3 == 1 then
        SetData("Particle.DetailObject", "Clod3")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        CreateExplosion("Clod3", 0, 0.75, 0, 0, 45)
        StartTimer("respawnbaddie", 500)
    end
    
    if Vampyr4 == 4 then
        Vampyr4 = Vampyr4 - 1
    elseif Vampyr4 == 3 then
        Vampyr4 = Vampyr4 - 1
    elseif Vampyr4 == 2 then
        Vampyr4 = Vampyr4 - 1
        TextControl = TextControl + 1
        SayEnemyNextTurn()
    elseif Vampyr4 == 1 then
        SetData("Particle.DetailObject", "Clod4")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        CreateExplosion("Clod4", 0, 0.75, 0, 0, 45)
        StartTimer("respawnbaddie", 500)
    end
    
    if Vampyr5 == 4 then
        Vampyr5 = Vampyr5 - 1
    elseif Vampyr5 == 3 then
        Vampyr5 = Vampyr5 - 1
    elseif Vampyr5 == 2 then
        Vampyr5 = Vampyr5 - 1
        TextControl = TextControl + 1
        SayEnemyNextTurn()
    elseif Vampyr5 == 1 then
        SetData("Particle.DetailObject", "Clod5")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        CreateExplosion("Clod5", 0, 0.75, 0, 0, 45)
        StartTimer("respawnbaddie", 500)
    end
    
    if Vampyr6 == 4 then
        Vampyr6 = Vampyr6 - 1
    elseif Vampyr6 == 3 then
        Vampyr6 = Vampyr6 - 1
    elseif Vampyr6 == 2 then
        Vampyr6 = Vampyr6 - 1
        TextControl = TextControl + 1
        SayEnemyNextTurn()
    elseif Vampyr6 == 1 then
        SetData("Particle.DetailObject", "Clod6")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        CreateExplosion("Clod6", 0, 0.75, 0, 0, 45)
        StartTimer("respawnbaddie", 500)
    end
    
    if Vampyr7 == 4 then
        Vampyr7 = Vampyr7 - 1
    elseif Vampyr7 == 3 then
        Vampyr7 = Vampyr7 - 1
    elseif Vampyr7 == 2 then
        Vampyr7 = Vampyr7 - 1
        TextControl = TextControl + 1
        SayEnemyNextTurn()
    elseif Vampyr7 == 1 then
        SetData("Particle.DetailObject", "Clod7")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        CreateExplosion("Clod7", 0, 0.75, 0, 0, 45)
        StartTimer("respawnbaddie", 500)
    end
    
    if Vampyr8 == 4 then
        Vampyr8 = Vampyr8 - 1
    elseif Vampyr8 == 3 then
        Vampyr8 = Vampyr8 - 1
    elseif Vampyr8 == 2 then
        Vampyr8 = Vampyr8 - 1
        TextControl = TextControl + 1
        SayEnemyNextTurn()
    elseif Vampyr8 == 1 then
        SetData("Particle.DetailObject", "Clod8")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        CreateExplosion("Clod8", 0, 0.75, 0, 0, 45)
        StartTimer("respawnbaddie", 500)
    end
end

function blankvariables()
    Vampyr1 = 0
    Vampyr2 = 0
    Vampyr3 = 0
    Vampyr4 = 0
    Vampyr5 = 0
    Vampyr6 = 0
    Vampyr7 = 0
    Vampyr8 = 0
end

function makeLOCATIONS()
    SetData("Trigger.Spawn", "Location1")
    SetData("Trigger.Radius", 60)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Location2")
    SetData("Trigger.Radius", 80)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Location3")
    SetData("Trigger.Radius", 70)
    SetData("Trigger.Index", 3)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Location4")
    SetData("Trigger.Radius", 60)
    SetData("Trigger.Index", 4)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Location5")
    SetData("Trigger.Radius", 80)
    SetData("Trigger.Index", 5)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Location6")
    SetData("Trigger.Radius", 50)
    SetData("Trigger.Index", 6)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Location7")
    SetData("Trigger.Radius", 50)
    SetData("Trigger.Index", 7)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Location8")
    SetData("Trigger.Radius", 60)
    SetData("Trigger.Index", 8)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
end

function Trigger_Collected()
    TriggerIndex = GetData("Trigger.Index")    
    if TriggerIndex == 1 then
        SetData("CommentaryPanel.Comment", "Highstakes.1")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Particle.DetailObject", "Clod1")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        baddie = 1
        randomtext()
        --CreateExplosion("Clod1", 0, KExpPush, 0, 0, KExpPush)--kpush1
        StartTimer("spawnbaddie", 500)
    elseif TriggerIndex == 2 then
        SetData("CommentaryPanel.Comment", "Highstakes.1")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Particle.DetailObject", "Clod2")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        baddie = 2
        randomtext()
        StartTimer("spawnbaddie", 500)
    elseif TriggerIndex == 3 then
        SetData("CommentaryPanel.Comment", "Highstakes.1")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Particle.DetailObject", "Clod3")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        baddie = 3
        randomtext()
        StartTimer("spawnbaddie", 500)
    elseif TriggerIndex == 4 then
        SetData("CommentaryPanel.Comment", "Highstakes.1")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Particle.DetailObject", "Clod4")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        baddie = 4
        randomtext()
        StartTimer("spawnbaddie", 500)
    elseif TriggerIndex == 5 then
        SetData("CommentaryPanel.Comment", "Highstakes.1")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Particle.DetailObject", "Clod5")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        baddie = 5
        randomtext()
        StartTimer("spawnbaddie", 500)
    elseif TriggerIndex == 6 then
        SetData("CommentaryPanel.Comment", "Highstakes.1")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Particle.DetailObject", "Clod6")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        baddie = 6
        randomtext()
        StartTimer("spawnbaddie", 500)
    elseif TriggerIndex == 7 then
        SetData("CommentaryPanel.Comment", "Highstakes.1")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Particle.DetailObject", "Clod7")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        baddie = 7
        randomtext()
        StartTimer("spawnbaddie", 500)
    elseif TriggerIndex == 8 then
        SetData("CommentaryPanel.Comment", "Highstakes.1")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Particle.DetailObject", "Clod8")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        baddie = 8
        randomtext()
        StartTimer("spawnbaddie", 500)
    end
end

-- grant        - braindead brucie
-- kel          - eaten alive aston
-- jd           - deathwish dennis
-- dunstan      - dead dead dunstan
-- dimond       - decomposing dimond
-- kilburn      - cursed kilburn
-- jegg         - etheral eggett
-- alex         - hellbound hannay

function spawnbaddie()
    if baddie == 1 then
        Vampyr1 = 0
        lock, worm = EditContainer("Worm.Data04") 
        worm.Active = true
        worm.Name = "brained bruce"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr1"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 4)
        CopyContainer("AIParams.CPU2", "AIParams.Worm04")
        lock, worm = EditContainer("AIParams.Worm04") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    elseif baddie == 2 then
        Vampyr2 = 0
        lock, worm = EditContainer("Worm.Data05")
        worm.Active = true
        worm.Name = "eaten alive aston"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr2"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 5)
        CopyContainer("AIParams.CPU2", "AIParams.Worm05")
        lock, worm = EditContainer("AIParams.Worm05") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    elseif baddie == 3 then
        Vampyr3 = 0
        lock, worm = EditContainer("Worm.Data06")
        worm.Active = true
        worm.Name = "departed dennis"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr3"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 6)
        CopyContainer("AIParams.CPU2", "AIParams.Worm06")
        lock, worm = EditContainer("AIParams.Worm06") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    elseif baddie == 4 then
        Vampyr4 = 0
        lock, worm = EditContainer("Worm.Data07")
        worm.Active = true
        worm.Name = "long dead dunstan"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr4"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 7)
        CopyContainer("AIParams.CPU2", "AIParams.Worm07")
        lock, worm = EditContainer("AIParams.Worm07") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    elseif baddie == 5 then
        Vampyr5 = 0
        lock, worm = EditContainer("Worm.Data08")
        worm.Active = true
        worm.Name = "decomposing dimond"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr5"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 8)
        CopyContainer("AIParams.CPU2", "AIParams.Worm08")
        lock, worm = EditContainer("AIParams.Worm08") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    elseif baddie == 6 then
        Vampyr6 = 0
        lock, worm = EditContainer("Worm.Data09")
        worm.Active = true
        worm.Name = "killed off kilburn"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr6"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 9)
        CopyContainer("AIParams.CPU2", "AIParams.Worm09")
        lock, worm = EditContainer("AIParams.Worm09") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    elseif baddie == 7 then
        Vampyr7 = 0
        lock, worm = EditContainer("Worm.Data10")
        worm.Active = true
        worm.Name = "ethereal eggett"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr7"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 10)
        CopyContainer("AIParams.CPU2", "AIParams.Worm10")
        lock, worm = EditContainer("AIParams.Worm10") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    elseif baddie == 8 then
        Vampyr8 = 0
        lock, worm = EditContainer("Worm.Data11")
        worm.Active = true
        worm.Name = "hellbound hannay"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr8"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 11)
        CopyContainer("AIParams.CPU2", "AIParams.Worm11")
        lock, worm = EditContainer("AIParams.Worm11") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    end
end

function respawnbaddie()
    if Vampyr1 == 1 then
        Vampyr1 = 0
        lock, worm = EditContainer("Worm.Data04") 
        worm.Active = true
        worm.Name = "braindead brucie"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr1"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 4)
        CopyContainer("AIParams.CPU2", "AIParams.Worm04")
        lock, worm = EditContainer("AIParams.Worm04") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    elseif Vampyr2 == 1 then
        Vampyr2 = 0
        lock, worm = EditContainer("Worm.Data05")
        worm.Active = true
        worm.Name = "eaten alive aston"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr2"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 5)
        CopyContainer("AIParams.CPU2", "AIParams.Worm05")
        lock, worm = EditContainer("AIParams.Worm05") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    elseif Vampyr3 == 1 then
        Vampyr3 = 0
        lock, worm = EditContainer("Worm.Data06")
        worm.Active = true
        worm.Name = "deathwish dennis"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr3"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 6)
        CopyContainer("AIParams.CPU2", "AIParams.Worm06")
        lock, worm = EditContainer("AIParams.Worm06") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    elseif Vampyr4 == 1 then
        Vampyr4 = 0
        lock, worm = EditContainer("Worm.Data07")
        worm.Active = true
        worm.Name = "dead dead dunstan"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr4"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 7)
        CopyContainer("AIParams.CPU2", "AIParams.Worm07")
        lock, worm = EditContainer("AIParams.Worm07") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    elseif Vampyr5 == 1 then
        Vampyr5 = 0
        lock, worm = EditContainer("Worm.Data08")
        worm.Active = true
        worm.Name = "decomposing dimond"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr5"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 8)
        CopyContainer("AIParams.CPU2", "AIParams.Worm08")
        lock, worm = EditContainer("AIParams.Worm08") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    elseif Vampyr6 == 1 then
        Vampyr6 = 0
        lock, worm = EditContainer("Worm.Data09")
        worm.Active = true
        worm.Name = "cursed kilburn"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr6"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 9)
        CopyContainer("AIParams.CPU2", "AIParams.Worm09")
        lock, worm = EditContainer("AIParams.Worm09") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    elseif Vampyr7 == 1 then
        Vampyr7 = 0
        lock, worm = EditContainer("Worm.Data10")
        worm.Active = true
        worm.Name = "etheral eggett"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUVampyr7"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 10)
        CopyContainer("AIParams.CPU2", "AIParams.Worm10")
        lock, worm = EditContainer("AIParams.Worm10") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    elseif Vampyr8 == 1 then
        Vampyr8 = 0
        lock, worm = EditContainer("Worm.Data11")
        worm.Active = true
        worm.Name = "Undead 8"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "hellbound hannay"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 11)
        CopyContainer("AIParams.CPU2", "AIParams.Worm11")
        lock, worm = EditContainer("AIParams.Worm11") 
        worm.ForbidShotsWhenMightAffectAITrigger = 1
        CloseContainer(lock) 
    end
end

function randomtext()
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 3) + 1
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Highstakes.2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Highstakes.3")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Highstakes.4")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

function Weapon_Created()
    worm = QueryWormContainer()
    if worm.WeaponIndex == "WeaponBaseballBat" then
        BatUsed = 1
    else
        BatUsed = 0
    end
end

function Worm_Died()
    deadworm = GetData("DeadWorm.Id")
    if deadworm == 0 then
        if draculadead == 0 then
            SetData("CommentaryPanel.Comment", "Highstakes.5")
            SendMessage("CommentaryPanel.ScriptText")
            undead = 1
            SpawnWhere()
        end
    elseif deadworm == 1 then
        if draculadead == 0 then
            SetData("CommentaryPanel.Comment", "Highstakes.6")
            SendMessage("CommentaryPanel.ScriptText")
            undead = 2
            SpawnWhere()
        end
    elseif deadworm == 2 then
        if Switch == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif deadworm == 3 then
        CurrentWorm = GetData("ActiveWormIndex")
        if BatUsed == 1 and CurrentWorm == 2 then
            draculadead = 1
            -- need to check for teams here
            TeamCount = GetData("TeamCount")
            if TeamCount > 1 then 
                SendMessage("Commentary.Clear")
                SetData("CommentaryPanel.Comment", "Highstakes.9")
                SendMessage("CommentaryPanel.ScriptText")
                SetData("CommentaryPanel.Comment", "Highstakes.10")
                SendMessage("CommentaryPanel.ScriptText")
            end
        else
            SetData("CommentaryPanel.Comment", "Highstakes.12")
            SendMessage("CommentaryPanel.ScriptText")
            SetData("CommentaryPanel.Comment", "Highstakes.13")
            SendMessage("CommentaryPanel.ScriptText")        
            SetData("Particle.DetailObject", "Clod0")
            SetData("Particle.Name", "Part_Gravedust")
            SendMessage("Particle.NewEmitter")
            CreateExplosion("Clod0", 0, 0.75, 0, 0, 45)
            StartTimer("SpawnDracuworm", 500)
        end
    elseif deadworm == 4 then
        lock, worm = EditContainer("Worm.Data04")
        worm.Energy = 0
        CloseContainer(lock)
        Vampyr1 = 4
    elseif deadworm == 5 then
        lock, worm = EditContainer("Worm.Data05")
        worm.Energy = 0
        CloseContainer(lock)
        Vampyr2 = 4
    elseif deadworm == 6 then
        lock, worm = EditContainer("Worm.Data06")
        worm.Energy = 0
        CloseContainer(lock)
        Vampyr3 = 4
    elseif deadworm == 7 then
        lock, worm = EditContainer("Worm.Data07")
        worm.Energy = 0
        CloseContainer(lock)
        Vampyr4 = 4
    elseif deadworm == 8 then
        lock, worm = EditContainer("Worm.Data08")
        worm.Energy = 0
        CloseContainer(lock)
        Vampyr5 = 4
    elseif deadworm == 9 then
        lock, worm = EditContainer("Worm.Data09")
        worm.Energy = 0
        CloseContainer(lock)
        Vampyr6 = 4
    elseif deadworm == 10 then
        lock, worm = EditContainer("Worm.Data10")
        worm.Energy = 0
        CloseContainer(lock)
        Vampyr7 = 4
    elseif deadworm == 11 then
        lock, worm = EditContainer("Worm.Data11")
        worm.Energy = 0
        CloseContainer(lock)
        Vampyr8 = 4
    end
end

function CheckOneTeamVictory()
    TeamCount = GetData("TeamCount")
    WhichTeam = GetData("SurvivingTeamIndex")
    
    if TeamCount == 0 then
        if Switch == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 2 then
        if Switch == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 0 and draculadead == 1 then
        SetData("CommentaryPanel.Comment", "Highstakes.11")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.generic.success")
        SendMessage("CommentaryPanel.ScriptText")
        Switch = 1
        endmissionsuccess()
    else
        StartTurn()
    end
end

function SpawnDracuworm()
    lock, worm = EditContainer("Worm.Data03") 
    worm.Active = true
    worm.Name = "Dracuworm"
    worm.IsAllowedToTakeTurn = false
    worm.Energy = 10
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    worm.SfxBankName = "Horror"
    worm.Spawn = "CPUWorm1"
    CloseContainer(lock)

    SendIntMessage("Worm.Respawn", 3)
end

function SpawnWhere()
    if undead == 1 and baddie == 0 then
        SetData("Particle.DetailObject", "HUClod0")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data00") 
        worm.Active = true
        worm.Name = "Zombie Cohort1"
        worm.Energy = 45
        --!!worm.DamagePending = -10
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman0"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 0)
        --!!SendMessage("GameLogic.ApplyDamage")
        -- send text here "Cohort 1 has been turned into a Zombie!!"
    elseif undead == 1 and baddie == 1 then
        SetData("Particle.DetailObject", "HUClod1")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data00") 
        worm.Active = true
        worm.Name = "Zombie Cohort1"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman1"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 0)
        -- send text here "Cohort 1 has been turned into a Zombie!!"
    elseif undead == 1 and baddie == 2 then
        lock, worm = EditContainer("Worm.Data00")
        SetData("Particle.DetailObject", "HUClod2")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        worm.Active = true
        worm.Name = "Zombie Cohort1"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman2"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 0)
        -- send text here "Cohort 1 has been turned into a Zombie!!"
    elseif undead == 1 and baddie == 3 then
        lock, worm = EditContainer("Worm.Data00")
        SetData("Particle.DetailObject", "HUClod3")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        worm.Active = true
        worm.Name = "Zombie Cohort1"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman3"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 0)
        -- send text here "Cohort 1 has been turned into a Zombie!!"
    elseif undead == 1 and baddie == 4 then
        SetData("Particle.DetailObject", "HUClod4")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data00") 
        worm.Active = true
        worm.Name = "Zombie Cohort1"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman4"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 0)
        -- send text here "Cohort 1 has been turned into a Zombie!!"
    elseif undead == 1 and baddie == 5 then
        SetData("Particle.DetailObject", "HUClod5")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data00") 
        worm.Active = true
        worm.Name = "Zombie Cohort1"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman5"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 0)
        -- send text here "Cohort 1 has been turned into a Zombie!!"
    elseif undead == 1 and baddie == 6 then
        SetData("Particle.DetailObject", "HUClod6")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data00") 
        worm.Active = true
        worm.Name = "Zombie Cohort1"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman6"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 0)
        -- send text here "Cohort 1 has been turned into a Zombie!!"
    elseif undead == 1 and baddie == 7 then
        SetData("Particle.DetailObject", "HUClod7")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data00") 
        worm.Active = true
        worm.Name = "Zombie Cohort1"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman7"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 0)
        -- send text here "Cohort 1 has been turned into a Zombie!!"
    elseif undead == 1 and baddie == 8 then
        SetData("Particle.DetailObject", "HUClod8")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data00") 
        worm.Active = true
        worm.Name = "Zombie Cohort1"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman8"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 0)
        -- send text here "Cohort 1 has been turned into a Zombie!!"
    elseif undead == 2 and baddie == 0 then
        SetData("Particle.DetailObject", "HUClod2_0")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data01") 
        worm.Active = true
        worm.Name = "Zombie Cohort2"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman2_0"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 1)
        -- send text here "Cohort 1 has been turned into a Zombie!!"
    elseif undead == 2 and baddie == 1 then
        SetData("Particle.DetailObject", "HUClod2_1")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data01") 
        worm.Active = true
        worm.Name = "Zombie Cohort2"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman2_1"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 1)
        -- send text here "Cohort 2 has been turned into a Zombie!!"
    elseif undead == 2 and baddie == 2 then
        SetData("Particle.DetailObject", "HUClod2_2")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data01") 
        worm.Active = true
        worm.Name = "Zombie Cohort2"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman2_2"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 1)
        -- send text here "Cohort 2 has been turned into a Zombie!!"
    elseif undead == 2 and baddie == 3 then
        SetData("Particle.DetailObject", "HUClod2_3")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data01") 
        worm.Active = true
        worm.Name = "Zombie Cohort2"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman2_3"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 1)
        -- send text here "Cohort 2 has been turned into a Zombie!!"
    elseif undead == 2 and baddie == 4 then
        SetData("Particle.DetailObject", "HUClod2_4")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data01") 
        worm.Active = true
        worm.Name = "Zombie Cohort2"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman2_4"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 1)
        -- send text here "Cohort 2 has been turned into a Zombie!!"
    elseif undead == 2 and baddie == 5 then
        SetData("Particle.DetailObject", "HUClod2_5")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data01") 
        worm.Active = true
        worm.Name = "Zombie Cohort2"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman2_5"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 1)
        -- send text here "Cohort 2 has been turned into a Zombie!!"
    elseif undead == 2 and baddie == 6 then
        SetData("Particle.DetailObject", "HUClod2_6")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data01") 
        worm.Active = true
        worm.Name = "Zombie Cohort2"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman2_6"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 1)
        -- send text here "Cohort 2 has been turned into a Zombie!!"
    elseif undead == 2 and baddie == 7 then
        SetData("Particle.DetailObject", "HUClod2_7")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data01") 
        worm.Active = true
        worm.Name = "Zombie Cohort2"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman2_7"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 1)
        -- send text here "Cohort 2 has been turned into a Zombie!!"
    elseif undead == 2 and baddie == 8 then
        SetData("Particle.DetailObject", "HUClod2_8")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        lock, worm = EditContainer("Worm.Data01") 
        worm.Active = true
        worm.Name = "Zombie Cohort2"
        worm.Energy = 45
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 2
        worm.DamagePending = 0
        worm.SfxBankName = "Horror"
        worm.Spawn = "CPUHuman2_8"
        CloseContainer(lock)
        SendIntMessage("Worm.Respawn", 1)
        -- send text here "Cohort 2 has been turned into a Zombie!!"
    end
end

function endmissionsuccess()
    Result()
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        Key,Lock = EditContainer("L.C.SS1")
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName2","L.C.SS1")
        end
        CloseContainer(Key)
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.L.High")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.High")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
  --  team.SfxBankName = GM.T1_Speech
    team.TeamColour = 0
    CloseContainer(lock)
    
-- TEAM WOULD IDEALLY BE DUMMY    
    lock, team = EditContainer("Team.Data01")
    team.Active = true
    team.Name = "Dracuworm"
    team.TeamColour = 1
    team.AlliedGroup = 1
    team.IsAIControlled = true
    team.FlagGfxName = "92"
    team.GraveIndex = 100
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data02")
    team.Active = true
    team.Name = "The Undead"
    team.IsAIControlled = true
    team.TeamColour = 1
    team.AlliedGroup = 1
    team.FlagGfxName = "95"
    team.GraveIndex = 100
    CloseContainer(lock)
    
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "HumanWorm2"
    CloseContainer(lock) 
    
    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm3"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data01", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = "Van Wormsing"
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm1"
    CloseContainer(lock)
    
    lock, worm = EditContainer("Worm.Data03") 
    worm.Active = true
    worm.Name = "Dracuworm"
    worm.IsAllowedToTakeTurn = false
    worm.Energy = 10
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    worm.SfxBankName = "Horror"
    worm.Spawn = "CPUWorm1"
    CloseContainer(lock)

    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Prod = -1
    inventory.Grenade = -1
    inventory.FirePunch = 4
    inventory.Parachute = 3
    inventory.Shotgun = -1
    inventory.SkipGo = -1
    --inventory.Jetpack = -1
    CloseContainer(lock)

    CopyContainer("Inventory.Team.Default", "Inventory.Team01")
    lock, inventory = EditContainer("Inventory.Team01")
    inventory.Parachute = 0
    inventory.SkipGo	= -1
    CloseContainer(lock)
    
    CopyContainer("Inventory.Team.Default", "Inventory.Team02")
    lock, inventory = EditContainer("Inventory.Team02") 
    inventory.Prod = -1
    --inventory.FirePunch = -1
    inventory.Shotgun = 10
    inventory.ClusterGrenade = -1
    inventory.SkipGo	= -1
    CloseContainer(lock)
    
    lock, inventory = EditContainer("Inventory.Worm02") 
    inventory.BaseballBat = -1
    CloseContainer(lock)
end


--/////////////////////////////////////////////////////////
--// pick from a bunch of message at the end of the game //
--/////////////////////////////////////////////////////////

function FailureMessages()
    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end

function SuccessMessages()
    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end

