
-- Kev's basic mission script
-- look at function_WhichWormDead
-- Mission needs Worm select to be turned on constantly

function Initialise()
    bronzetime = (60 * 1000) * 999
    silvertime = 370000 
    goldtime = 340000
    
    SendMessage("EFMV.Start")
    
    SetData("Mine.DudProbabilty", 1.0)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SendMessage("GameLogic.PlaceObjects")
    SetData("Land.Indestructable", 1)
    
    SetData("Particle.Rain.Prob", 0)
    SetData("Particle.Snow.Prob", 0)
    
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")
    SetData("HUD.Clock.DisplayRoundTime", 0)
    SendMessage("GameLogic.ResetTriggerParams")

    makeTEAM17()
    makePCB()
    makeMISC()
    resetValues()

    WormDead = 0
    CollectedMines = 0
    MinePhase = 1
    TextControl = 0
    TextMineControl = 1
    SparkControl = 0
    Dont = 0
    Switch = 0
    DontStartTurn = 0
    
    SetData("TurnTime", 45000)
    SetData("HotSeatTime", 3000)
    SetData("RoundTime", 000000)

    SetData("Crate.Spawn", "Health")
    SetData("Crate.Type", "Health")
    SetData("Crate.NumContents", 40)
    SetData("Crate.Pushable", 0)
    SetData("Crate.TeamDestructible", 10)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Health2")
    SetData("Crate.Type", "Health")
    SetData("Crate.NumContents", 40)
    SetData("Crate.Pushable", 0)
    SetData("Crate.TeamDestructible", 10)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Cluster")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 3)
    SetData("Crate.Contents", "kWeaponClusterGrenade")
    SetData("Crate.Pushable", 0)
    SetData("Crate.Index", 51)
    SetData("Crate.TeamDestructible", 10)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Shotgun")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 2)
    SetData("Crate.Contents", "kWeaponShotgun")
    SetData("Crate.Pushable", 0)
    SetData("Crate.Index", 51)
    SetData("Crate.TeamDestructible", 10)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    Drips()
    CameraFly = 1
    
    SendStringMessage("Camera.Disable", "Blimp")
    SendStringMessage("Camera.Disable", "Spectator")
    
    SpawnMines()
    SetupWormsAndTeams()
    SetupInventories()
    First()
end

function resetValues()
    PCB3 = 0
    PCB2 = 0
    PCB5 = 0
    PCB8 = 0
    PCB12 = 0
    PCB16 = 0
    WRONGMOVE = 0
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        SendMessage("Commentary.Clear")
        if Line6AnimRunning == 1 then
            CancelTimer(AnimLoop)
        end
        CancelTimer(CamLoop)
        CameraFinished()
    end
end

function CameraFinished()
    SetData("Worm.Blink", 0)
    SendIntMessage("Worm.SetBlink", 0)
    SendMessage("EFMV.End")
    CameraFly = 0
    --StartTimer("InGameCamWin", 2000)
    StartFirstTurn()
end
 
function First()
    SetData("Camera.Path.Knots.Position", "FirstCam,FirstCam2")
    SetData("Camera.Path.Knots.LookAt", "FirstLook,FirstLook2")
    SetData("Camera.Path.Steps.Position",440)
    SetData("Camera.Path.Steps.LookAt",440) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Second", 4000)
end

function Second()
    SetData("Camera.Path.Knots.Position", "SecondCam,SecondCam2")
    SetData("Camera.Path.Knots.LookAt", "SecondLook")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",500) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line1", 3500)
end

function Line1()
    SetData("CommentaryPanel.Comment", "Miss.NotPC.game1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line1Cam,Line1Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line1Look")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line2", 3000)
end

function Line2()
    SetData("CommentaryPanel.Comment", "Miss.NotPC.game2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line2Cam,Line2Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line2Look,Line2Look2")
    SetData("Camera.Path.Steps.Position",800)
    SetData("Camera.Path.Steps.LookAt",800) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line3", 3500)
end

function Line3()
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Shocked1")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Embarrassed1")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("CommentaryPanel.Comment", "Miss.NotPC.game3")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line3Cam")
    SetData("Camera.Path.Knots.LookAt", "Line3Look")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Enem1", 2500)
end

function Enem1()
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "NotMe4")
    SendIntMessage("Worm.QueueAnim", 2)

    SetData("CommentaryPanel.Comment", "Miss.NotPC.game4")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Enem1Cam")
    SetData("Camera.Path.Knots.LookAt", "Enem1Look")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Enem2", 1200)
end

function Enem2()
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Taunt1")
    SendIntMessage("Worm.QueueAnim", 3)

    SetData("Camera.Path.Knots.Position", "Enem2Cam")
    SetData("Camera.Path.Knots.LookAt", "Enem2Look")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Enem3", 1200)
end

function Enem3()
    SendIntMessage("Worm.ResetAnim", 4)
    SetData("Worm.ScriptAnim", "Smug2")
    SendIntMessage("Worm.QueueAnim", 4)
    
    SetData("Worm.Blink", 0)
    SendIntMessage("Worm.SetBlink", 1)

    SetData("Camera.Path.Knots.Position", "Enem3Cam")
    SetData("Camera.Path.Knots.LookAt", "Enem3Look")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line5", 1200)
end

function Line5()
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Asleep")
    SendIntMessage("Worm.QueueAnim", 1)

    SetData("CommentaryPanel.Comment", "Miss.NotPC.game5")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line5Cam,Line5Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line5Look")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",500) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line6", 3500)
end

function Line6()
    AnimLoop = StartTimer("Line6Anim", 800)
    Line6AnimRunning = 1
    SetData("CommentaryPanel.Comment", "Miss.NotPC.game6")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line6Cam")
    SetData("Camera.Path.Knots.LookAt", "Line6Look")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line7", 3000)
end

function Line6Anim()
    Line6AnimRunning = 0
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Shocked1")
    SendIntMessage("Worm.QueueAnim", 1)
    SetData("Worm.ScriptAnim", "NotMe5")
    SendIntMessage("Worm.QueueAnim", 1)
end

function Line7()
    SetData("CommentaryPanel.Comment", "Miss.NotPC.game7")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line7Cam,Line7Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line7Look")
    SetData("Camera.Path.Steps.Position",700)
    SetData("Camera.Path.Steps.LookAt",700) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("CameraFinished", 5000)
end
-- cameras end here
--function StartTurn()
--   done_once_per_turn_functions = false
--   SendMessage("Timer.StartHotSeatTimer")
--   SendMessage("GameLogic.ActivateNextWorm")
--   SendMessage("Weapon.Create")
--   SendMessage("GameLogic.Turn.Started")
--   TurnStarted() -- moved here so TeleportIn camera can override startofturn camera
--   RunAILogic()
--end

function TurnStarted()
    Team = GetData("CurrentTeamIndex")
    if Team == 0 then
        SendMessage("WormSelect.OptionSelected")
    end
end

function TurnEnded()
    if DontStartTurn == 0 then
        CheckOneTeamVictory()
    end
end

function CheckOneTeamVictory()
    SendMessage("WormManager.GetActiveTeamCount")
    TeamCount = GetData("TeamCount")
   
    SendMessage("WormManager.GetSurvivingTeam")
    TeamLeft = GetData("SurvivingTeamIndex")
   if TeamCount == 0 then
        if Switch == 0 then
            --RoundOver()
            -- all the teams have just snuffed it
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
   elseif TeamCount == 1 and TeamLeft == 1 then
           if Switch == 0 then
            --RoundOver()
            -- all the teams have just snuffed it
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
   else
      StartTurn()
   end
end

function Drips()
    SetData("Particle.DetailObject", "Drip1")
    SetData("Particle.Name", "Part_Drips")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Drip2")
    SetData("Particle.Name", "Part_Drips")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Drip3")
    SetData("Particle.Name", "Part_Drips")
    SendMessage("Particle.NewEmitter")
end

function SpawnMines()
    if TextMineControl == 2 then
        SendMessage("Commentary.Clear")
        SetData("CommentaryPanel.Comment", "Miss.Timbers.game14")
        SendMessage("CommentaryPanel.ScriptText")
    elseif TextMineControl == 1 then
        TextMineControl = 2
    end

    if MinePhase == 1 then
        MinePhase = 2
    
        SetData("Crate.Spawn", "Mines1")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 2)
        SetData("Crate.Contents", "kWeaponLandmine")
        SetData("Crate.Pushable", 0)
        SetData("Crate.Index", 50)
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        
        SetData("Crate.Spawn", "Mines2")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 2)
        SetData("Crate.Contents", "kWeaponLandmine")
        SetData("Crate.Pushable", 0)
        SetData("Crate.Index", 50)
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        
        SetData("Crate.Spawn", "Mines3")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 2)
        SetData("Crate.Contents", "kWeaponLandmine")
        SetData("Crate.Pushable", 0)
        SetData("Crate.Index", 50)
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
    elseif MinePhase == 2 then
        MinePhase = 1
    
        SetData("Crate.Spawn", "Mines1A")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 2)
        SetData("Crate.Contents", "kWeaponLandmine")
        SetData("Crate.Pushable", 0)
        SetData("Crate.Index", 50)
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        
        SetData("Crate.Spawn", "Mines2A")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 2)
        SetData("Crate.Contents", "kWeaponLandmine")
        SetData("Crate.Pushable", 0)
        SetData("Crate.Index", 50)
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        
        SetData("Crate.Spawn", "Mines3A")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 2)
        SetData("Crate.Contents", "kWeaponLandmine")
        SetData("Crate.Pushable", 0)
        SetData("Crate.Index", 50)
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
    end
end

function makeTEAM17()
    Team17 = 000000

    SendIntMessage("GameLogic.DestroyTrigger", 1)
    SendIntMessage("GameLogic.DestroyTrigger", 2)
    SendIntMessage("GameLogic.DestroyTrigger", 3)
    SendIntMessage("GameLogic.DestroyTrigger", 4)
    SendIntMessage("GameLogic.DestroyTrigger", 5)
    SendIntMessage("GameLogic.DestroyTrigger", 6)
    SendIntMessage("GameLogic.DestroyTrigger", 7)

    SetData("Trigger.Spawn", "T")
    SetData("Trigger.Radius", 4)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "E")
    SetData("Trigger.Radius", 4)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "A")
    SetData("Trigger.Radius", 4)
    SetData("Trigger.Index", 3)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "M")
    SetData("Trigger.Radius", 4)
    SetData("Trigger.Index", 4)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "1")
    SetData("Trigger.Radius", 6)
    SetData("Trigger.Index", 5)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "7")
    SetData("Trigger.Radius", 6)
    SetData("Trigger.Index", 6)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "1b")
    SetData("Trigger.Radius", 6)
    SetData("Trigger.Index", 5)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "7b")
    SetData("Trigger.Radius", 6)
    SetData("Trigger.Index", 6)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
end

function makePCB()
    SetData("Trigger.Spawn", "PCB1")
    SetData("Trigger.Radius", 13)
    SetData("Trigger.Index", 10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.PayloadCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB2")
    SetData("Trigger.Index", 11)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB3")
    SetData("Trigger.Index", 12)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB4")
    SetData("Trigger.Index", 13)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB5")
    SetData("Trigger.Index", 14)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB6")
    SetData("Trigger.Index", 15)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB7")
    SetData("Trigger.Index", 16)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB8")
    SetData("Trigger.Index", 17)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB9")
    SetData("Trigger.Index", 18)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB10")
    SetData("Trigger.Index", 19)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB11")
    SetData("Trigger.Index", 20)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB12")
    SetData("Trigger.Index", 21)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB13")
    SetData("Trigger.Index", 22)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB14")
    SetData("Trigger.Index", 23)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB15")
    SetData("Trigger.Index", 24)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB16")
    SetData("Trigger.Index", 25)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "PCB17")
    SetData("Trigger.Index", 26)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SendMessage("GameLogic.CreateTrigger")
end

function killPCB()
    SendIntMessage("GameLogic.DestroyTrigger", 10)
    SendIntMessage("GameLogic.DestroyTrigger", 11)
    SendIntMessage("GameLogic.DestroyTrigger", 12)
    SendIntMessage("GameLogic.DestroyTrigger", 13)
    SendIntMessage("GameLogic.DestroyTrigger", 14)
    SendIntMessage("GameLogic.DestroyTrigger", 15)
    SendIntMessage("GameLogic.DestroyTrigger", 16)
    SendIntMessage("GameLogic.DestroyTrigger", 17)
    SendIntMessage("GameLogic.DestroyTrigger", 18)
    SendIntMessage("GameLogic.DestroyTrigger", 19)
    SendIntMessage("GameLogic.DestroyTrigger", 20)
    SendIntMessage("GameLogic.DestroyTrigger", 21)
    SendIntMessage("GameLogic.DestroyTrigger", 22)
    SendIntMessage("GameLogic.DestroyTrigger", 23)
    SendIntMessage("GameLogic.DestroyTrigger", 24)
    SendIntMessage("GameLogic.DestroyTrigger", 25)
    SendIntMessage("GameLogic.DestroyTrigger", 26)
end

function makeMISC()
    SetData("Trigger.Spawn", "Power")
    SetData("Trigger.Radius", 4)
    SetData("Trigger.Index", 30)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.PayloadCollect", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
end

function Trigger_PayloadCollected()
    TriggerIndex = GetData("Trigger.Index")    
    if TriggerIndex == 12 then
        PCB3 = 1
        if SparkControl == 0 then
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Miss.NotPC.game9")
            SendMessage("CommentaryPanel.ScriptText")
            
            SetData("Particle.DetailObject", "ValvePart3")
            SetData("Particle.Name", "Part_ElectricSpark")
            SendMessage("Particle.NewEmitter")
            valvespark = GetData("Particle.Handle")
            StartTimer("DeleteSpark", 2000)
        end
    elseif TriggerIndex == 11 then
        PCB2 = 1
        if SparkControl == 0 then
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Miss.NotPC.game9")
            SendMessage("CommentaryPanel.ScriptText")
        
            SetData("Particle.DetailObject", "ValvePart2")
            SetData("Particle.Name", "Part_ElectricSpark")
            SendMessage("Particle.NewEmitter")
            valvespark = GetData("Particle.Handle")
            StartTimer("DeleteSpark", 2000)
        end
    elseif TriggerIndex == 14 then
        PCB5 = 1
        if SparkControl == 0 then
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Miss.NotPC.game9")
            SendMessage("CommentaryPanel.ScriptText")
        
            SetData("Particle.DetailObject", "ValvePart5")
            SetData("Particle.Name", "Part_ElectricSpark")
            SendMessage("Particle.NewEmitter")
            valvespark = GetData("Particle.Handle")
            StartTimer("DeleteSpark", 2000)
        end
    elseif TriggerIndex == 17 then
        PCB8 = 1
        if SparkControl == 0 then
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Miss.NotPC.game9")
            SendMessage("CommentaryPanel.ScriptText")
        
            SetData("Particle.DetailObject", "ValvePart8")
            SetData("Particle.Name", "Part_ElectricSpark")
            SendMessage("Particle.NewEmitter")
            valvespark = GetData("Particle.Handle")
            StartTimer("DeleteSpark", 2000)
        end
    elseif TriggerIndex == 21 then
        PCB12 = 1
        if SparkControl == 0 then
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Miss.NotPC.game9")
            SendMessage("CommentaryPanel.ScriptText")
        
            SetData("Particle.DetailObject", "ValvePart12")
            SetData("Particle.Name", "Part_ElectricSpark")
            SendMessage("Particle.NewEmitter")
            valvespark = GetData("Particle.Handle")
            StartTimer("DeleteSpark", 2000)
        end
    elseif TriggerIndex == 25 then
        PCB16 = 1
        if SparkControl == 0 then
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Miss.NotPC.game9")
            SendMessage("CommentaryPanel.ScriptText")
        
            SetData("Particle.DetailObject", "ValvePart16")
            SetData("Particle.Name", "Part_ElectricSpark")
            SendMessage("Particle.NewEmitter")
            valvespark = GetData("Particle.Handle")
            StartTimer("DeleteSpark", 2000)
        end
    else
        WRONGMOVE = 1
    end
end

function DeleteSpark()
    SendIntMessage("Particle.DeleteEmitter",valvespark)
end

function Trigger_Collected()
    TrigIndex = GetData("Trigger.Index")
    if TrigIndex == 1 then 
        if Team17 == 000000 then Team17 = 100000
            StartTimer("SendText", 1000)
        else
            StartTimer("SpellMistake", 1000)
        end
    elseif TrigIndex == 2 then
        if Team17 == 100000 then Team17 = 110000
            StartTimer("SendText", 1000)
        -- TE
        else
            StartTimer("SpellMistake", 1000)
        end
    elseif TrigIndex == 3 then
        if Team17 == 110000 then Team17 = 111000
            StartTimer("SendText", 1000)
        -- TEA
        else
            StartTimer("SpellMistake", 1000)
        end
    elseif TrigIndex == 4 then
        if Team17 == 111000 then Team17 = 111100
            StartTimer("SendText", 1000)
        -- TEAM
        else
            StartTimer("SpellMistake", 1000)
        end
    elseif TrigIndex == 5 then
        if Team17 == 111100 then Team17 = 111110
            StartTimer("SendText", 1000)
            SendIntMessage("GameLogic.DestroyTrigger", 5)
        -- TEAM1
        else
            StartTimer("SpellMistake", 1000)
        end
    elseif TrigIndex == 6 then
        if Team17 == 111110 then Team17 = 111111
            StartTimer("SendText", 1000)
            SendIntMessage("GameLogic.DestroyTrigger", 6)
        -- TEAM17
        else
            StartTimer("SpellMistake", 1000)
        end
    elseif TrigIndex == 30 then
        DontStartTurn = 1
        SparkControl = 1
        SendMessage("GameLogic.RoundTime.Pause")
        SendMessage("GameLogic.TurnTime.Pause")
        SendStringMessage("Camera.Disable", "Track")
        CheckWiring()
        StartTimer("InGameDecideCam", 0800)
    end
end

function CheckWiring()
    resetValues()
    killPCB()
    makePCB()
end

function SpellMistake()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.NotPC.egg7")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("makeTEAM17", 1000)
end

function InGameDecideCam()
    SendMessage("EFMV.Start")
    SetData("Camera.Path.Knots.Position", "PreDecisionCam,PreDecisionCam2")
    SetData("Camera.Path.Knots.LookAt", "PreDecisionLook")
    SetData("Camera.Path.Steps.Position",450)
    SetData("Camera.Path.Steps.LookAt",450)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    SetData("Particle.DetailObject", "PCBSpark1")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
    ids1 = GetData("Particle.Handle")
    SetData("Particle.DetailObject", "PCBSpark2")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
    ids2 = GetData("Particle.Handle")
    
    if PCB3 == 1 and PCB2 == 1 and PCB5 == 1 and PCB8 == 1 and PCB12 == 1 and PCB16 == 1 and WRONGMOVE == 0 then
        if Switch == 0 then
            StartTimer("InGameCamWin", 2500)
            Switch = 1
        end
    else
        StartTimer("InGameCam", 2500)
    end
end

function InGameCam()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.NotPC.game10")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.NotPC.game11")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "WrongMoveCam,WrongMoveCam2")
    SetData("Camera.Path.Knots.LookAt", "WrongMoveLook")
    SetData("Camera.Path.Steps.Position",550)
    SetData("Camera.Path.Steps.LookAt",550)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    SendStringMessage("Payload.ForceExpiry", "kWeaponLandmine")
    StartTimer("Explosion", 0700)
    StartTimer("InGameCamEnd", 4500)
end

function Explosion()
    CreateExplosion("SwitchBlow", 0, 0.75, 0, 0, 50)
    CreateExplosion("Explosion", 0, 0.35, 150, 300, 80)
    SetData("Camera.Shake.Length",1000)
    SetData("Camera.Shake.Magnitude",0.30)
    SendMessage("Camera.ShakeStart")
    SetData("Particle.DetailObject", "Explosion")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
end

function InGameCamEnd()
    SendIntMessage("Particle.DeleteEmitter",ids1)
    SendIntMessage("Particle.DeleteEmitter",ids2)
    SendMessage("GameLogic.RoundTime.Resume")
    SendMessage("GameLogic.TurnTime.Resume")
    SendMessage("EFMV.End")
    SendStringMessage("Camera.Enable", "Track")
    SparkControl = 0
    makeMISC()
    DontStartTurn = 0
    CheckWiring()
    GameLogic_EndTurn_Immediate()
end

function InGameCamWin()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.NotPC.success")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.generic.success")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "RightMoveCam,RightMoveCam2")
    SetData("Camera.Path.Knots.LookAt", "RightMoveLook")
    SetData("Camera.Path.Steps.Position",550)
    SetData("Camera.Path.Steps.LookAt",550)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    endmissionsuccess()
end

function Crate_Collected()
    CrateNumber = GetData("Crate.Index")
    if CrateNumber == 50 then
        if TextControl == 0 then
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Miss.NotPC.game8")
            SendMessage("CommentaryPanel.ScriptText")
            TextControl = 1
        end
    
        CollectedMines = CollectedMines + 1
        if CollectedMines == 3 then
            CollectedMines = 0
            SpawnMines()
        end
    end
end

function endmissionsuccess()

    Result()

end

--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()

    SetData("Camera.Path.IgnoreInput", 1)
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1
 
        if timetook < silvertime then
            Movie = 2
            
            if timetook < goldtime then
                Movie = 3
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end


function endmissionfail()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.generic.fail")
    SendMessage("CommentaryPanel.ScriptText")
    SendMessage("GameLogic.Mission.Failure")
end

function SendText()
    if Team17 == 100000 then
        SetData("CommentaryPanel.Comment", "Miss.NotPC.egg1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif Team17 == 110000 then
        SetData("CommentaryPanel.Comment", "Miss.NotPC.egg2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif Team17 == 111000 then
        SetData("CommentaryPanel.Comment", "Miss.NotPC.egg3")
        SendMessage("CommentaryPanel.ScriptText")
    elseif Team17 == 111100 then
        SetData("CommentaryPanel.Comment", "Miss.NotPC.egg4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif Team17 == 111110 then
        SetData("CommentaryPanel.Comment", "Miss.NotPC.egg5")
        SendMessage("CommentaryPanel.ScriptText")
    elseif Team17 == 111111 then
        SetData("CommentaryPanel.Comment", "Miss.NotPC.egg6")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.NotPC.egg8")
        SendMessage("CommentaryPanel.ScriptText")
        
        Key,Lock = EditContainer("L.S.Lover") --French Lover sfx bank
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName","L.S.Lover")
        end
        CloseContainer(Key)
        
    end
end

-- this looks at which Worms died, to end the mission
--function Worm_Died()
--    deadworm = GetData("DeadWorm.Id")
--    if deadworm == 0 or deadworm == 1 then
--        WormDead = WormDead + 1
--        WhichWormDead()
--    end
--end

function WhichWormDead()
    if WormDead == 2 then
        if Switch == 0 then
            -- insert some end of mission text here
            endmissionfail()
            Switch = 1
        end
    end
end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "Technophobes"
    team.IsAIControlled = true
    team.FlagGfxName = "68"
    team.TeamColour = 1
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm1"
    CloseContainer(lock) 

    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm2"
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data02") 
    worm.Active = true
    worm.Name = "Luddite"
    worm.Energy = 50
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    worm.SfxBankName = "Hippy"
    worm.Spawn = "CPUWorm1"
    CloseContainer(lock)
    CopyContainer("AIParams.CPU3", "AIParams.Worm02")

    CopyContainer("Worm.Data02", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03") 
    worm.Name = "Lennon"
    worm.Spawn = "CPUWorm2"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm02", "AIParams.Worm03")

    CopyContainer("Worm.Data03", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04") 
    worm.Name = "Lolita"
    worm.Spawn = "CPUWorm3"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm02", "AIParams.Worm04")
    
    CopyContainer("Worm.Data04", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05") 
    worm.Name = "Lorraine"
    worm.Spawn = "CPUWorm4"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm02", "AIParams.Worm05")
    
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Grenade = -1
    inventory.Bazooka = 5
    inventory.FirePunch = -1
    inventory.Parachute = 2
    inventory.SkipGo = -1
    CloseContainer(lock)

    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Grenade = -1
    inventory.FirePunch = -1
    inventory.BaseballBat = -1
    inventory.SkipGo = -1
    CloseContainer(lock)
end


--/////////////////////////////////////////////////////////
--// pick from a bunch of message at the end of the game //
--/////////////////////////////////////////////////////////


function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
    
end
