
-- ! Landscape has a hole in land next to skull, Worm falls in here and cannot get out again.  Needs filling.

-- ! Mission wants to have game set to "Worm Select" - so player can always tab through active Worms.
-- ! Mission is awaiting game collision to be a bit steadier, captain Worm gets stuck bouncing around on boat.
-- ! Mission needs CPU skill level toning down or the ability to stop the CPU from attacking the captain worm.

function Initialise()
    bronzetime = (60 * 1000) * 999
    silvertime = 490000
    goldtime = 440000
    
    SetData("TurnTime", 45000)
    SetData("HotSeatTime", 3000)
    SetData("RoundTime", 0)
    SetData("HUD.Clock.DisplayRoundTime", 0)
    
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SendMessage("GameLogic.PlaceObjects")
    SetData("Jetpack.InitFuel", 2500)

    SendMessage("EFMV.Start")
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")
    
    SetData("Particle.DetailObject", "Butterflies")
    SetData("Particle.Name", "Part_Butterfly")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Butterflies2")
    SetData("Particle.Name", "Part_Butterfly")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Butterflies3")
    SetData("Particle.Name", "Part_Butterfly")
    SendMessage("Particle.NewEmitter")
    
    SetData("Crate.Spawn", "GirderMarked")
    SetData("Crate.Type", "Utility")
    SetData("Crate.Contents", "kUtilityGirder")
    SetData("Crate.Index", 4)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.NumContents", 1)
    SetData("Crate.TeamCollectable", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "GirderMarked2")
    SetData("Crate.Type", "Utility")
    SetData("Crate.Contents", "kUtilityGirder")
    SetData("Crate.Index", 5)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.NumContents", 1)
    SetData("Crate.TeamCollectable", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "GirderMarked3")
    SetData("Crate.Type", "Utility")
    SetData("Crate.Contents", "kUtilityGirder")
    SetData("Crate.Index", 6)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.NumContents", 1)
    SetData("Crate.TeamCollectable", 0)
    SendMessage("GameLogic.CreateCrate")

    SetData("Trigger.Spawn", "ProtectWreck")
    SetData("Trigger.Radius", 80)
    SetData("Trigger.Index", 10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")    
    
    MakeBoatTriggers()
    MakeCapTriggers()

    deadplayers = 0
    AllEnemyDead = 0
    --CaptainOnShip = 0
    GotGrenades = 0
    GrenadeRound = 1
    CrateDropCam = 0
    CaptainOK = 0
    CapOnBoat = 0
    KGameWon = 0
    cratecount = 0
    CameraFly = 1
    CamTextControl = 0
    CapTurnCam = 0
    Switch = 0
    turn = 0
    
    SelectRandomWind()
    SetupWormsAndTeams()
    SetupInventories()
    RotateIsland()
end


function Camera_Path_Stopped()
    if CameraFly == 1 then
        SendMessage("Commentary.Clear")
        if CamTextControl == 1 then
            CamTextControl = 0
            CancelTimer(CamTextLoop)
        end
        SendMessage("EFMV.End")
        CameraFly = 0
        CancelTimer(CamLoop)
        MakeGrenades()
        StartFirstTurn()
    end
    
    if CrateDropCam == 1 then
        SendMessage("EFMV.End")
        CrateDropCam = 0
        CancelTimer(CrateDropCamEndWait)
        ResumeGame()
        -- return third person cam to active worm
    end
    
    if CapTurnCam == 1 then
        SendMessage("EFMV.End")
        SendMessage("Commentary.Clear")
        CapTurnCam = 0
        CancelTimer(CapTurnCamEndWait)
        CaptainCamEnd()
    end
end

function CameraFinished()
    SendMessage("EFMV.End")
    CameraFly = 0
    MakeGrenades()
    StartFirstTurn()
end
-- cameras start
function RotateIsland()
    SetData("Camera.Path.Knots.Position", "CamSweep1,CamSweep5")
    SetData("Camera.Path.Knots.LookAt", "Centre")
    SetData("Camera.Path.Tension.Position", 1)
    SetData("Camera.Path.Steps.Position",800)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CamTextLoop = StartTimer("FirstText", 2000)
    CamTextControl = 1
    CamLoop = StartTimer("EnemCam1", 5000)
end

function FirstText()
    CamTextControl = 0
    SetData("CommentaryPanel.Comment", "Miss.Timbers.game1")
    SendMessage("CommentaryPanel.ScriptText")
end

function EnemCam1()
    SetData("CommentaryPanel.Comment", "Miss.Timbers.game2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "EnemCam1")
    SetData("Camera.Path.Knots.LookAt", "EnemCam1Look,EnemCam1Look2")
    SetData("Camera.Path.Tension.Position", 0)
    SetData("Camera.Path.Steps.Position",0)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("EnemCam2", 1500)
    
    SendIntMessage("Worm.ResetAnim", 6)
    SetData("Worm.ScriptAnim", "Taunt1")
    SendIntMessage("Worm.QueueAnim", 6)
end

function EnemCam2()
    SetData("Camera.Path.Knots.Position", "EnemCam2")
    SetData("Camera.Path.Knots.LookAt", "EnemCam2Look,EnemCam2Look2")
    SetData("Camera.Path.Tension.Position", 0)
    SetData("Camera.Path.Steps.Position",0)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("EnemCam3", 1500)
    
    SendIntMessage("Worm.ResetAnim", 7)
    SetData("Worm.ScriptAnim", "Yawn")
    SendIntMessage("Worm.QueueAnim", 7)
end

function EnemCam3()
    SetData("Camera.Path.Knots.Position", "EnemCam3")
    SetData("Camera.Path.Knots.LookAt", "EnemCam3Look,EnemCam3Look2")
    SetData("Camera.Path.Tension.Position", 0)
    SetData("Camera.Path.Steps.Position",0)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("EnemCam4", 1500)
    
    SendIntMessage("Worm.ResetAnim", 5)
    SetData("Worm.ScriptAnim", "Smug2")
    SendIntMessage("Worm.QueueAnim", 5)
end

function EnemCam4()
    SetData("Camera.Path.Knots.Position", "EnemCam4")
    SetData("Camera.Path.Knots.LookAt", "EnemCam4Look,EnemCam4Look2")
    SetData("Camera.Path.Tension.Position", 0)
    SetData("Camera.Path.Steps.Position",0)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("LookAtShip", 1500)
    
    SendIntMessage("Worm.ResetAnim", 4)
    SetData("Worm.ScriptAnim", "Scowl2")
    SendIntMessage("Worm.QueueAnim", 4)
end

function LookAtShip()
    SetData("CommentaryPanel.Comment", "Miss.Timbers.game3")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "LookAtShipCam,LookAtShipCam2")
    SetData("Camera.Path.Knots.LookAt", "LookAtShipLook")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("LookAtCapn", 3000)
    
    SendIntMessage("Worm.ResetAnim", 4)
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 4)
end

function LookAtCapn()
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "OverHere")
    SendIntMessage("Worm.QueueAnim", 3)
    SetData("CommentaryPanel.Comment", "Miss.Timbers.game4")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "LookAtCapnCam")
    SetData("Camera.Path.Knots.LookAt", "LookAtCapnLook")
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("LookAtBetween", 3500)
end

function LookAtBetween()
    SetData("CommentaryPanel.Comment", "Miss.Timbers.game5")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Timbers.game6")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "LookAtBetweenCam,LookAtBetweenCam2")
    SetData("Camera.Path.Knots.LookAt", "LookAtBetweenLook")
    SetData("Camera.Path.Steps.Position",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("CameraFinished", 6000)
end
-- cameras end
function MakeGrenades()
    SendMessage("Commentary.Clear")

    SetData("Crate.Spawn", "Grenade1")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 100)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.TeamCollectable", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Grenade2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 100)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.TeamCollectable", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Grenade3")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 100)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.TeamCollectable", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Grenade4")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 100)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.TeamCollectable", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Grenade5")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 100)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.TeamCollectable", 0)
    SendMessage("GameLogic.CreateCrate")

    SetData("CommentaryPanel.Comment", "Miss.Timbers.game14")
    SendMessage("CommentaryPanel.ScriptText")

    StartTimer("KillExtraText", 0400)
end

function MakeGrenadesA()
    SendMessage("Commentary.Clear")

    SetData("Crate.Spawn", "Grenade1a")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 100)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.TeamCollectable", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Grenade2a")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 100)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.TeamCollectable", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Grenade3a")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 100)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.TeamCollectable", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Grenade4a")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 100)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.TeamCollectable", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Grenade5a")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 100)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.TeamCollectable", 0)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("CommentaryPanel.Comment", "Miss.Timbers.game14")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("KillExtraText", 0400)
end

function KillExtraText()
    SendMessage("Commentary.Clear")
end

function MakeBoatTriggers()
    SetData("Trigger.Spawn", "OnBoat1")
    SetData("Trigger.Radius", 40)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "OnBoat2")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "OnBoat3")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "OnBoat4")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "OnBoat5")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "OnBoat6")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "OnBoat7")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 1)
    SetData("Trigger.Radius", 20)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "OnBoat8")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 1)
    SetData("Trigger.Radius", 20)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
end

function MakeCapTriggers()
    SetData("Trigger.Spawn", "CapNMove")
    SetData("Trigger.Radius", 80)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove2")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove3")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove4")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove5")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove6")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMoveA")
    SetData("Trigger.Radius", 50)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove2A")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove3A")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove4A")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove5A")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove6A")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMoveB")
    SetData("Trigger.Radius", 50)
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove2B")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove3B")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove4B")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove5B")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "CapNMove6B")
    SetData("Trigger.TeamDestroy", 10)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.WormCollect", 3)
    SendMessage("GameLogic.CreateTrigger")
end

function Trigger_Collected()
    TriggerIndex = GetData("Trigger.Index")

    if TriggerIndex == 2 then
        CaptainOK = 1
        SendIntMessage("GameLogic.DestroyTrigger", 2)
    elseif TriggerIndex == 1 and AllEnemyDead == 4 then
        SendMessage("Commentary.Clear")
        SendIntMessage("GameLogic.DestroyTrigger", 1)
        SetData("CommentaryPanel.Comment", "Miss.Timbers.game10")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Timbers.game11")
        SendMessage("CommentaryPanel.ScriptText")
        KGameWon = 1
        endmissionsuccess()
    else
        CapOnBoat = 1
        SendIntMessage("GameLogic.DestroyTrigger", 1)
        StartTimer("MakeBoatTriggers", 1000)
    end
end

function LookInvent()
    inventory = QueryContainer("Inventory.Team00")
    if inventory.Girder > 0 then
        CaptainOK = 1
    end
end

function Worm_Died()
    deadWorm = GetData("DeadWorm.Id")
    if deadWorm == 0 or deadWorm == 1 or deadWorm == 2 then
        deadplayers = deadplayers + 1
        if deadplayers == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Timbers.game8")
        SendMessage("CommentaryPanel.ScriptText")
        LookInvent()
            if CaptainOK == 0 then
                if Switch == 0 then
                    SetData("CommentaryPanel.Comment", "Miss.Timbers.game16")
                    SendMessage("CommentaryPanel.ScriptText")
                    endmissionfail()
                    Switch = 1
                end
            end
        end
    end
    
    if deadWorm == 3 then
        if Switch == 0 then
            SetData("CommentaryPanel.Comment", "Miss.Timbers.game9")
            SendMessage("CommentaryPanel.ScriptText")
            endmissionfail()
            Switch = 1
        end
    end
    
    if deadWorm == 4 or deadWorm == 5 or deadWorm == 6 or deadWorm == 7 then
        AllEnemyDead = AllEnemyDead + 1
        deadwormtext()
    end
end

function deadwormtext()
    if AllEnemyDead == 4 then
        StartTimer("senddeadtext", 500)
    end
end

function senddeadtext()
    if CapOnBoat == 0 then
        SetData("CommentaryPanel.Comment", "Miss.Timbers.game7")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

function PauseGame()
    SendMessage("GameLogic.RoundTime.Pause")
    SendMessage("GameLogic.TurnTime.Pause")
    SendMessage("GameLogic.PauseGame")
    SendStringMessage("Camera.Disable", "Track")
    SetData("GameLogic.ArtilleryMode", 1)
end

function ResumeGame()
    SendMessage("GameLogic.RoundTime.Resume")
    SendMessage("GameLogic.TurnTime.Resume")
    SendMessage("GameLogic.ResumeGame")
    SendStringMessage("Camera.Enable", "Track")
    SetData("GameLogic.ArtilleryMode", 0)
end

function TurnStarted()
    Worm = GetData("ActiveWormIndex")
    if Worm == 3 and KGameWon == 0 and CapOnBoat == 0 and deadplayers < 3 then
        PauseGame()
        StartTimer("CaptainCam", 0100)
        --CaptainCam()
    end
    
    turn = turn + 1
end
--bm1
function TurnEnded()
    CheckOneTeamVictory()
end

function FailureMessages()
    SendMessage("Commentary.Clear")
    
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end

function CheckOneTeamVictory()
    SendMessage("WormManager.GetActiveTeamCount")
    TeamCount = GetData("TeamCount")
    if TeamCount == 0 then
        if Switch == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    else
        StartTurn()
    end
end

function CaptainCam()
    CapTurnCam = 1
    SendMessage("Commentary.Clear")
    SendMessage("EFMV.Start")
    SetData("CommentaryPanel.Comment", "Miss.Timbers.game5")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Timbers.game6")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "InGameCam,InGameCam2")
    SetData("Camera.Path.Knots.LookAt", "InGameLook")
    SetData("Camera.Path.Tension.Position", 0)
    SetData("Camera.Path.Steps.Position",800)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CapTurnCamEndWait = StartTimer("CaptainCamEnd", 5500)
end

function CaptainCamEnd()
    SendMessage("EFMV.End")
    ResumeGame()
    SendMessage("Camera.SetDefault")
end

function PauseGame()
    SendMessage("GameLogic.RoundTime.Pause")
    SendMessage("GameLogic.TurnTime.Pause")
    SendMessage("GameLogic.PauseGame")
    SendStringMessage("Camera.Disable", "Track")
    SetData("GameLogic.ArtilleryMode", 1)
end

function ResumeGame()
    SendMessage("GameLogic.RoundTime.Resume")
    SendMessage("GameLogic.TurnTime.Resume")
    SendMessage("GameLogic.ResumeGame")
    SendStringMessage("Camera.Enable", "Track")
    SetData("GameLogic.ArtilleryMode", 0)
end

function CrateDropCamLoop()
    CrateDropCam = 1
    SendMessage("EFMV.Start")
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.Timbers.game12")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "CDropCam,CDropCam2")
    SetData("Camera.Path.Knots.LookAt", "CDropLook")
    SetData("Camera.Path.Tension.Position", 0)
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.IgnoreInput", 1)
    SetData("Camera.Path.Steps.LookAt",0) 
    SendMessage("Camera.Path.Start")
    CrateDropCamEndWait = StartTimer("CrateDropCamLoopEnd", 5000)
end

function CrateDropCamLoopEnd()
    CrateDropCam = 0
    SendMessage("EFMV.End")
    ResumeGame()
    SendMessage("Camera.SetDefault")
end

function Crate_Collected()
    CrateIndex = GetData("Crate.Index")
    if CrateIndex == 4 or CrateIndex == 5 or CrateIndex == 6 then
        cratecount = cratecount + 1
        if cratecount == 1 or cratecount == 2 then
            SetData("CommentaryPanel.Comment", "Miss.Grave.game12")
            SendMessage("CommentaryPanel.ScriptText")
        elseif cratecount == 3 then
            SetData("Crate.Spawn", "JetpackMarked")
            SetData("Crate.Type", "Utility")
            SetData("Crate.Contents", "kUtilityJetpack")
            SetData("Crate.Index", 7)
            SetData("Crate.NumContents", 1)
            SetData("Crate.TeamCollectable", 0)
            SendMessage("GameLogic.CreateCrate")
            PauseGame()
            StartTimer("CrateDropCamLoop", 300)
        end
    elseif CrateIndex == 7 then
        SetData("CommentaryPanel.Comment", "Miss.Timbers.game13")
        SendMessage("CommentaryPanel.ScriptText")
    elseif CrateIndex == 100 then
        GotGrenades = GotGrenades + 1
        if GotGrenades == 5 and GrenadeRound == 1 then
            SendMessage("Commentary.Clear")
            MakeGrenadesA()
            GotGrenades = 0
            GrenadeRound = 2
        elseif GotGrenades == 5 and GrenadeRound == 2 then
            SendMessage("Commentary.Clear")
            MakeGrenades()
            GotGrenades = 0
            GrenadeRound = 1
        end
    end
end

function Crate_Destroyed()
    CrateIndex = GetData("Crate.Index")
    if CrateIndex == 100 then
    GotGrenades = GotGrenades + 1
        if GotGrenades == 5 and GrenadeRound == 1 then
            SetData("CommentaryPanel.Comment", "Miss.Timbers.game14")
            SendMessage("CommentaryPanel.ScriptText")
            MakeGrenadesA()
            GotGrenades = 0
            GrenadeRound = 2
        elseif GotGrenades == 5 and GrenadeRound == 2 then
            SetData("CommentaryPanel.Comment", "Miss.Timbers.game14")
            SendMessage("CommentaryPanel.ScriptText")
            MakeGrenades()
            GotGrenades = 0
            GrenadeRound = 1
        end
    end
end

function endmissionsuccess()

    Result()
    
end



--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.L.Timbers")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Timbers")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

function endmissionfail()
    SetData("CommentaryPanel.Comment", "Miss.generic.fail")
    SendMessage("CommentaryPanel.ScriptText")
    SendMessage("GameLogic.Mission.Failure")
end

function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "Pirates"
    team.FlagGfxName = "94"
    team.IsAIControlled = true
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "HumanWorm1"
    CloseContainer(lock) 

    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm2"
    CloseContainer(lock)

    CopyContainer("Worm.Data01", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02")
    worm.Name = GM.T1_W3_Name    
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm3"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data02", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03")
    worm.Energy = 80
    --worm.IsHatWearer = true
    worm.Name = "Captain"
    worm.Spawn = "HatWorm1"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Energy = 80 
    worm.Name = "Scurvy"
    worm.TeamIndex = 1
    worm.SfxBankName = "Pirate"
    worm.Spawn = "CPUWorm1"
    CloseContainer(lock)
    CopyContainer("AIParams.CPU2", "AIParams.Worm04")
    lock, worm = EditContainer("AIParams.Worm04") 
    worm.ForbidShotsWhenMightAffectAITrigger = 1
    CloseContainer(lock)

    CopyContainer("Worm.Data04", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    worm.Energy = 80  
    worm.Name = "Typhoid"
    worm.Spawn = "CPUWorm2"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm04", "AIParams.Worm05")

    CopyContainer("Worm.Data05", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06")
    worm.Energy = 80  
    worm.Name = "Cargo"
    worm.Spawn = "CPUWorm3"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm04", "AIParams.Worm06")

    CopyContainer("Worm.Data06", "Worm.Data07")
    lock, worm = EditContainer("Worm.Data07")
    worm.Energy = 80  
    worm.Name = "Cutlass"
    worm.Spawn = "CPUWorm4"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm04", "AIParams.Worm07")
    
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Grenade = 0
    inventory.SkipGo = -1
    inventory.Bazooka = 4
    inventory.FirePunch = 1
    inventory.SkipGo = -1
    --inventory.Girder = 2
    --inventory.Jetpack = -1
    CloseContainer(lock)

    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Bazooka = -1
    inventory.Grenade = 0
    inventory.Shotgun = -1
    inventory.FirePunch = -1
    inventory.SkipGo = -1
    CloseContainer(lock)
end
